/*******************************************************************************
* FILE NAME: MnScreen.cpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   Class implementation of the class:                                         *
*     MainScreen- This is the main STP screen                                  *
* ---------------------------------------------------------------------------- *
* Warning: This file was generated by the VisualAge C++ Visual Builder.        *
* Modifications to this source file will be lost when the part is regenerated. *
*******************************************************************************/
#include <iframe.hpp>
#include <icolor.hpp>
#include <icanvas.hpp>
#include <istattxt.hpp>
#include <ifont.hpp>
#include <irect.hpp>
#include <ipoint.hpp>
#include <ientryfd.hpp>
#include <ipushbut.hpp>
#include <ibmpctl.hpp>
#include "RtrvData.hpp"
#include <ivbfly.hpp>
#include <iflyhhdr.hpp>
#include <inotifev.hpp>
#include <ivbconn.hpp>
#include "MnScreen.hpp"
#include <ivbmnstr.hpp>
#include <icoordsy.hpp>
#include <itrace.hpp>

//*****************************************************************************
// Class definition for MainScreenConn0
//*****************************************************************************
class MainScreenConn0 : public IVBConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn0(IPushButton * aSource, IFrameWindow * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
   };

   virtual  ~MainScreenConn0()
   {
      stopHandlingNotificationsFor(*source);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      return ((anEvent.notificationId() == IPushButton::buttonClickId));
   };
   void perform(const INotificationEvent & anEvent)
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : PushButton2(buttonClickEvent) to FrameWindow(close))");
      target->close();
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   IPushButton * source;
   IFrameWindow * target;


};   //MainScreenConn0


//*****************************************************************************
// Class definition for MainScreenConn1
//*****************************************************************************
class MainScreenConn1 : public IVBAttributeConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn1(RetrieveData * aSource, IEntryField * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
      handleNotificationsFor(*target);
   };

   virtual  ~MainScreenConn1()
   {
      stopHandlingNotificationsFor(*source);
      stopHandlingNotificationsFor(*target);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      if ((anEvent.notificationId() == RetrieveData::szCounterpartyId) && (source == &anEvent.notifier()))
         return sourceChanged;
      else
      if ((anEvent.notificationId() == IEntryField::textId) && (target == &anEvent.notifier()))
         return targetChanged;
      return skip;
   };
   virtual void performSetSource()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : RetrieveData(szCounterparty) to CounterPartyField(text))");
      ITRACE_DEVELOP(" setting source from target ");
      source->setSzCounterparty(target->text());
   };
   virtual void performSetTarget()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : RetrieveData(szCounterparty) to CounterPartyField(text))");
      ITRACE_DEVELOP(" setting target from source ");
      target->setText(source->szCounterparty());
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   RetrieveData * source;
   IEntryField * target;


};   //MainScreenConn1


//*****************************************************************************
// Class definition for MainScreenConn2
//*****************************************************************************
class MainScreenConn2 : public IVBAttributeConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn2(RetrieveData * aSource, IEntryField * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
      handleNotificationsFor(*target);
   };

   virtual  ~MainScreenConn2()
   {
      stopHandlingNotificationsFor(*source);
      stopHandlingNotificationsFor(*target);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      if ((anEvent.notificationId() == RetrieveData::szInternalRefId) && (source == &anEvent.notifier()))
         return sourceChanged;
      else
      if ((anEvent.notificationId() == IEntryField::textId) && (target == &anEvent.notifier()))
         return targetChanged;
      return skip;
   };
   virtual void performSetSource()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : RetrieveData(szInternalRef) to InternalRef(text))");
      ITRACE_DEVELOP(" setting source from target ");
      source->setSzInternalRef(target->text());
   };
   virtual void performSetTarget()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : RetrieveData(szInternalRef) to InternalRef(text))");
      ITRACE_DEVELOP(" setting target from source ");
      target->setText(source->szInternalRef());
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   RetrieveData * source;
   IEntryField * target;


};   //MainScreenConn2


//*****************************************************************************
// Class definition for MainScreenConn3
//*****************************************************************************
class MainScreenConn3 : public IVBAttributeConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn3(RetrieveData * aSource, IEntryField * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
      handleNotificationsFor(*target);
   };

   virtual  ~MainScreenConn3()
   {
      stopHandlingNotificationsFor(*source);
      stopHandlingNotificationsFor(*target);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      if ((anEvent.notificationId() == RetrieveData::szExternalRefId) && (source == &anEvent.notifier()))
         return sourceChanged;
      else
      if ((anEvent.notificationId() == IEntryField::textId) && (target == &anEvent.notifier()))
         return targetChanged;
      return skip;
   };
   virtual void performSetSource()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : RetrieveData(szExternalRef) to ExternalRefField(text))");
      ITRACE_DEVELOP(" setting source from target ");
      source->setSzExternalRef(target->text());
   };
   virtual void performSetTarget()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : RetrieveData(szExternalRef) to ExternalRefField(text))");
      ITRACE_DEVELOP(" setting target from source ");
      target->setText(source->szExternalRef());
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   RetrieveData * source;
   IEntryField * target;


};   //MainScreenConn3


//*****************************************************************************
// Class definition for MainScreenConn4
//*****************************************************************************
class MainScreenConn4 : public IVBAttributeConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn4(RetrieveData * aSource, IEntryField * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
      handleNotificationsFor(*target);
   };

   virtual  ~MainScreenConn4()
   {
      stopHandlingNotificationsFor(*source);
      stopHandlingNotificationsFor(*target);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      if ((anEvent.notificationId() == RetrieveData::szQuantityId) && (source == &anEvent.notifier()))
         return sourceChanged;
      else
      if ((anEvent.notificationId() == IEntryField::textId) && (target == &anEvent.notifier()))
         return targetChanged;
      return skip;
   };
   virtual void performSetSource()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : RetrieveData(szQuantity) to QtyField(text))");
      ITRACE_DEVELOP(" setting source from target ");
      source->setSzQuantity(target->text());
   };
   virtual void performSetTarget()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : RetrieveData(szQuantity) to QtyField(text))");
      ITRACE_DEVELOP(" setting target from source ");
      target->setText(source->szQuantity());
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   RetrieveData * source;
   IEntryField * target;


};   //MainScreenConn4


//*****************************************************************************
// Class definition for MainScreenConn5
//*****************************************************************************
class MainScreenConn5 : public IVBAttributeConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn5(RetrieveData * aSource, IEntryField * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
      handleNotificationsFor(*target);
   };

   virtual  ~MainScreenConn5()
   {
      stopHandlingNotificationsFor(*source);
      stopHandlingNotificationsFor(*target);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      if ((anEvent.notificationId() == RetrieveData::szBuySellId) && (source == &anEvent.notifier()))
         return sourceChanged;
      else
      if ((anEvent.notificationId() == IEntryField::textId) && (target == &anEvent.notifier()))
         return targetChanged;
      return skip;
   };
   virtual void performSetSource()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : RetrieveData(szBuySell) to BuySellField(text))");
      ITRACE_DEVELOP(" setting source from target ");
      source->setSzBuySell(target->text());
   };
   virtual void performSetTarget()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : RetrieveData(szBuySell) to BuySellField(text))");
      ITRACE_DEVELOP(" setting target from source ");
      target->setText(source->szBuySell());
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   RetrieveData * source;
   IEntryField * target;


};   //MainScreenConn5


//*****************************************************************************
// Class definition for MainScreenConn6
//*****************************************************************************
class MainScreenConn6 : public IVBAttributeConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn6(RetrieveData * aSource, IEntryField * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
      handleNotificationsFor(*target);
   };

   virtual  ~MainScreenConn6()
   {
      stopHandlingNotificationsFor(*source);
      stopHandlingNotificationsFor(*target);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      if ((anEvent.notificationId() == RetrieveData::szSettlementDateId) && (source == &anEvent.notifier()))
         return sourceChanged;
      else
      if ((anEvent.notificationId() == IEntryField::textId) && (target == &anEvent.notifier()))
         return targetChanged;
      return skip;
   };
   virtual void performSetSource()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : RetrieveData(szSettlementDate) to SettlementDateField(text))");
      ITRACE_DEVELOP(" setting source from target ");
      source->setSzSettlementDate(target->text());
   };
   virtual void performSetTarget()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : RetrieveData(szSettlementDate) to SettlementDateField(text))");
      ITRACE_DEVELOP(" setting target from source ");
      target->setText(source->szSettlementDate());
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   RetrieveData * source;
   IEntryField * target;


};   //MainScreenConn6


//*****************************************************************************
// Class definition for MainScreenConn7
//*****************************************************************************
class MainScreenConn7 : public IVBAttributeConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn7(RetrieveData * aSource, IEntryField * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
      handleNotificationsFor(*target);
   };

   virtual  ~MainScreenConn7()
   {
      stopHandlingNotificationsFor(*source);
      stopHandlingNotificationsFor(*target);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      if ((anEvent.notificationId() == RetrieveData::szSettlementTypeId) && (source == &anEvent.notifier()))
         return sourceChanged;
      else
      if ((anEvent.notificationId() == IEntryField::textId) && (target == &anEvent.notifier()))
         return targetChanged;
      return skip;
   };
   virtual void performSetSource()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : RetrieveData(szSettlementType) to SettlementTypeField(text))");
      ITRACE_DEVELOP(" setting source from target ");
      source->setSzSettlementType(target->text());
   };
   virtual void performSetTarget()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : RetrieveData(szSettlementType) to SettlementTypeField(text))");
      ITRACE_DEVELOP(" setting target from source ");
      target->setText(source->szSettlementType());
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   RetrieveData * source;
   IEntryField * target;


};   //MainScreenConn7


//*****************************************************************************
// Class definition for MainScreenConn8
//*****************************************************************************
class MainScreenConn8 : public IVBAttributeConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn8(RetrieveData * aSource, IEntryField * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
      handleNotificationsFor(*target);
   };

   virtual  ~MainScreenConn8()
   {
      stopHandlingNotificationsFor(*source);
      stopHandlingNotificationsFor(*target);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      if ((anEvent.notificationId() == RetrieveData::szCurrencyId) && (source == &anEvent.notifier()))
         return sourceChanged;
      else
      if ((anEvent.notificationId() == IEntryField::textId) && (target == &anEvent.notifier()))
         return targetChanged;
      return skip;
   };
   virtual void performSetSource()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : RetrieveData(szCurrency) to CurrencyField(text))");
      ITRACE_DEVELOP(" setting source from target ");
      source->setSzCurrency(target->text());
   };
   virtual void performSetTarget()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : RetrieveData(szCurrency) to CurrencyField(text))");
      ITRACE_DEVELOP(" setting target from source ");
      target->setText(source->szCurrency());
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   RetrieveData * source;
   IEntryField * target;


};   //MainScreenConn8


//*****************************************************************************
// Class definition for MainScreenConn9
//*****************************************************************************
class MainScreenConn9 : public IVBAttributeConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn9(RetrieveData * aSource, IEntryField * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
      handleNotificationsFor(*target);
   };

   virtual  ~MainScreenConn9()
   {
      stopHandlingNotificationsFor(*source);
      stopHandlingNotificationsFor(*target);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      if ((anEvent.notificationId() == RetrieveData::szConsiderationId) && (source == &anEvent.notifier()))
         return sourceChanged;
      else
      if ((anEvent.notificationId() == IEntryField::textId) && (target == &anEvent.notifier()))
         return targetChanged;
      return skip;
   };
   virtual void performSetSource()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : RetrieveData(szConsideration) to ConsiderationField(text))");
      ITRACE_DEVELOP(" setting source from target ");
      source->setSzConsideration(target->text());
   };
   virtual void performSetTarget()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : RetrieveData(szConsideration) to ConsiderationField(text))");
      ITRACE_DEVELOP(" setting target from source ");
      target->setText(source->szConsideration());
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   RetrieveData * source;
   IEntryField * target;


};   //MainScreenConn9


//*****************************************************************************
// Class definition for MainScreenConn10
//*****************************************************************************
class MainScreenConn10 : public IVBAttributeConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn10(RetrieveData * aSource, IEntryField * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
      handleNotificationsFor(*target);
   };

   virtual  ~MainScreenConn10()
   {
      stopHandlingNotificationsFor(*source);
      stopHandlingNotificationsFor(*target);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      if ((anEvent.notificationId() == RetrieveData::szStatusId) && (source == &anEvent.notifier()))
         return sourceChanged;
      else
      if ((anEvent.notificationId() == IEntryField::textId) && (target == &anEvent.notifier()))
         return targetChanged;
      return skip;
   };
   virtual void performSetSource()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : RetrieveData(szStatus) to StatusField(text))");
      ITRACE_DEVELOP(" setting source from target ");
      source->setSzStatus(target->text());
   };
   virtual void performSetTarget()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : RetrieveData(szStatus) to StatusField(text))");
      ITRACE_DEVELOP(" setting target from source ");
      target->setText(source->szStatus());
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   RetrieveData * source;
   IEntryField * target;


};   //MainScreenConn10


//*****************************************************************************
// Class definition for MainScreenConn11
//*****************************************************************************
class MainScreenConn11 : public IVBAttributeConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn11(RetrieveData * aSource, IEntryField * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
      handleNotificationsFor(*target);
   };

   virtual  ~MainScreenConn11()
   {
      stopHandlingNotificationsFor(*source);
      stopHandlingNotificationsFor(*target);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      if ((anEvent.notificationId() == RetrieveData::szTradeTypeId) && (source == &anEvent.notifier()))
         return sourceChanged;
      else
      if ((anEvent.notificationId() == IEntryField::textId) && (target == &anEvent.notifier()))
         return targetChanged;
      return skip;
   };
   virtual void performSetSource()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : RetrieveData(szTradeType) to TradeTypeField(text))");
      ITRACE_DEVELOP(" setting source from target ");
      source->setSzTradeType(target->text());
   };
   virtual void performSetTarget()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : RetrieveData(szTradeType) to TradeTypeField(text))");
      ITRACE_DEVELOP(" setting target from source ");
      target->setText(source->szTradeType());
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   RetrieveData * source;
   IEntryField * target;


};   //MainScreenConn11


//*****************************************************************************
// Class definition for MainScreenConn12
//*****************************************************************************
class MainScreenConn12 : public IVBAttributeConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn12(RetrieveData * aSource, IEntryField * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
      handleNotificationsFor(*target);
   };

   virtual  ~MainScreenConn12()
   {
      stopHandlingNotificationsFor(*source);
      stopHandlingNotificationsFor(*target);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      if ((anEvent.notificationId() == RetrieveData::szBookId) && (source == &anEvent.notifier()))
         return sourceChanged;
      else
      if ((anEvent.notificationId() == IEntryField::textId) && (target == &anEvent.notifier()))
         return targetChanged;
      return skip;
   };
   virtual void performSetSource()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : RetrieveData(szBook) to BookField(text))");
      ITRACE_DEVELOP(" setting source from target ");
      source->setSzBook(target->text());
   };
   virtual void performSetTarget()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : RetrieveData(szBook) to BookField(text))");
      ITRACE_DEVELOP(" setting target from source ");
      target->setText(source->szBook());
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   RetrieveData * source;
   IEntryField * target;


};   //MainScreenConn12


//*****************************************************************************
// Class definition for MainScreenConn13
//*****************************************************************************
class MainScreenConn13 : public IVBAttributeConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn13(RetrieveData * aSource, IEntryField * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
      handleNotificationsFor(*target);
   };

   virtual  ~MainScreenConn13()
   {
      stopHandlingNotificationsFor(*source);
      stopHandlingNotificationsFor(*target);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      if ((anEvent.notificationId() == RetrieveData::szMarketId) && (source == &anEvent.notifier()))
         return sourceChanged;
      else
      if ((anEvent.notificationId() == IEntryField::textId) && (target == &anEvent.notifier()))
         return targetChanged;
      return skip;
   };
   virtual void performSetSource()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : RetrieveData(szMarket) to MarketField(text))");
      ITRACE_DEVELOP(" setting source from target ");
      source->setSzMarket(target->text());
   };
   virtual void performSetTarget()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : RetrieveData(szMarket) to MarketField(text))");
      ITRACE_DEVELOP(" setting target from source ");
      target->setText(source->szMarket());
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   RetrieveData * source;
   IEntryField * target;


};   //MainScreenConn13


//*****************************************************************************
// Class definition for MainScreenConn14
//*****************************************************************************
class MainScreenConn14 : public IVBAttributeConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn14(RetrieveData * aSource, IEntryField * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
      handleNotificationsFor(*target);
   };

   virtual  ~MainScreenConn14()
   {
      stopHandlingNotificationsFor(*source);
      stopHandlingNotificationsFor(*target);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      if ((anEvent.notificationId() == RetrieveData::szMessageTypeId) && (source == &anEvent.notifier()))
         return sourceChanged;
      else
      if ((anEvent.notificationId() == IEntryField::textId) && (target == &anEvent.notifier()))
         return targetChanged;
      return skip;
   };
   virtual void performSetSource()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : RetrieveData(szMessageType) to MessageTypeField(text))");
      ITRACE_DEVELOP(" setting source from target ");
      source->setSzMessageType(target->text());
   };
   virtual void performSetTarget()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : RetrieveData(szMessageType) to MessageTypeField(text))");
      ITRACE_DEVELOP(" setting target from source ");
      target->setText(source->szMessageType());
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   RetrieveData * source;
   IEntryField * target;


};   //MainScreenConn14


//*****************************************************************************
// Class definition for MainScreenConn15
//*****************************************************************************
class MainScreenConn15 : public IVBAttributeConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn15(RetrieveData * aSource, IEntryField * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
      handleNotificationsFor(*target);
   };

   virtual  ~MainScreenConn15()
   {
      stopHandlingNotificationsFor(*source);
      stopHandlingNotificationsFor(*target);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      if ((anEvent.notificationId() == RetrieveData::szTradeDateId) && (source == &anEvent.notifier()))
         return sourceChanged;
      else
      if ((anEvent.notificationId() == IEntryField::textId) && (target == &anEvent.notifier()))
         return targetChanged;
      return skip;
   };
   virtual void performSetSource()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : RetrieveData(szTradeDate) to TradeDateField(text))");
      ITRACE_DEVELOP(" setting source from target ");
      source->setSzTradeDate(target->text());
   };
   virtual void performSetTarget()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : RetrieveData(szTradeDate) to TradeDateField(text))");
      ITRACE_DEVELOP(" setting target from source ");
      target->setText(source->szTradeDate());
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   RetrieveData * source;
   IEntryField * target;


};   //MainScreenConn15


//*****************************************************************************
// Class definition for MainScreenConn16
//*****************************************************************************
class MainScreenConn16 : public IVBAttributeConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn16(RetrieveData * aSource, IEntryField * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
      handleNotificationsFor(*target);
   };

   virtual  ~MainScreenConn16()
   {
      stopHandlingNotificationsFor(*source);
      stopHandlingNotificationsFor(*target);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      if ((anEvent.notificationId() == RetrieveData::szTradeTimeId) && (source == &anEvent.notifier()))
         return sourceChanged;
      else
      if ((anEvent.notificationId() == IEntryField::textId) && (target == &anEvent.notifier()))
         return targetChanged;
      return skip;
   };
   virtual void performSetSource()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : RetrieveData(szTradeTime) to TradeTimeField(text))");
      ITRACE_DEVELOP(" setting source from target ");
      source->setSzTradeTime(target->text());
   };
   virtual void performSetTarget()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : RetrieveData(szTradeTime) to TradeTimeField(text))");
      ITRACE_DEVELOP(" setting target from source ");
      target->setText(source->szTradeTime());
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   RetrieveData * source;
   IEntryField * target;


};   //MainScreenConn16


//*****************************************************************************
// Class definition for MainScreenConn17
//*****************************************************************************
class MainScreenConn17 : public IVBAttributeConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn17(RetrieveData * aSource, IEntryField * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
      handleNotificationsFor(*target);
   };

   virtual  ~MainScreenConn17()
   {
      stopHandlingNotificationsFor(*source);
      stopHandlingNotificationsFor(*target);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      if ((anEvent.notificationId() == RetrieveData::szDepotShortNameId) && (source == &anEvent.notifier()))
         return sourceChanged;
      else
      if ((anEvent.notificationId() == IEntryField::textId) && (target == &anEvent.notifier()))
         return targetChanged;
      return skip;
   };
   virtual void performSetSource()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : RetrieveData(szDepotShortName) to DepotShortField(text))");
      ITRACE_DEVELOP(" setting source from target ");
      source->setSzDepotShortName(target->text());
   };
   virtual void performSetTarget()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : RetrieveData(szDepotShortName) to DepotShortField(text))");
      ITRACE_DEVELOP(" setting target from source ");
      target->setText(source->szDepotShortName());
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   RetrieveData * source;
   IEntryField * target;


};   //MainScreenConn17


//*****************************************************************************
// Class definition for MainScreenConn18
//*****************************************************************************
class MainScreenConn18 : public IVBAttributeConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn18(RetrieveData * aSource, IEntryField * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
      handleNotificationsFor(*target);
   };

   virtual  ~MainScreenConn18()
   {
      stopHandlingNotificationsFor(*source);
      stopHandlingNotificationsFor(*target);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      if ((anEvent.notificationId() == RetrieveData::szDepotLongNameId) && (source == &anEvent.notifier()))
         return sourceChanged;
      else
      if ((anEvent.notificationId() == IEntryField::textId) && (target == &anEvent.notifier()))
         return targetChanged;
      return skip;
   };
   virtual void performSetSource()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : RetrieveData(szDepotLongName) to DepotLongField(text))");
      ITRACE_DEVELOP(" setting source from target ");
      source->setSzDepotLongName(target->text());
   };
   virtual void performSetTarget()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : RetrieveData(szDepotLongName) to DepotLongField(text))");
      ITRACE_DEVELOP(" setting target from source ");
      target->setText(source->szDepotLongName());
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   RetrieveData * source;
   IEntryField * target;


};   //MainScreenConn18


//*****************************************************************************
// Class definition for MainScreenConn19
//*****************************************************************************
class MainScreenConn19 : public IVBAttributeConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn19(RetrieveData * aSource, IEntryField * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
      handleNotificationsFor(*target);
   };

   virtual  ~MainScreenConn19()
   {
      stopHandlingNotificationsFor(*source);
      stopHandlingNotificationsFor(*target);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      if ((anEvent.notificationId() == RetrieveData::szNostrosShortNameId) && (source == &anEvent.notifier()))
         return sourceChanged;
      else
      if ((anEvent.notificationId() == IEntryField::textId) && (target == &anEvent.notifier()))
         return targetChanged;
      return skip;
   };
   virtual void performSetSource()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : RetrieveData(szNostrosShortName) to NostrosShortField(text))");
      ITRACE_DEVELOP(" setting source from target ");
      source->setSzNostrosShortName(target->text());
   };
   virtual void performSetTarget()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : RetrieveData(szNostrosShortName) to NostrosShortField(text))");
      ITRACE_DEVELOP(" setting target from source ");
      target->setText(source->szNostrosShortName());
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   RetrieveData * source;
   IEntryField * target;


};   //MainScreenConn19


//*****************************************************************************
// Class definition for MainScreenConn20
//*****************************************************************************
class MainScreenConn20 : public IVBAttributeConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn20(RetrieveData * aSource, IEntryField * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
      handleNotificationsFor(*target);
   };

   virtual  ~MainScreenConn20()
   {
      stopHandlingNotificationsFor(*source);
      stopHandlingNotificationsFor(*target);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      if ((anEvent.notificationId() == RetrieveData::szNostrosLongNameId) && (source == &anEvent.notifier()))
         return sourceChanged;
      else
      if ((anEvent.notificationId() == IEntryField::textId) && (target == &anEvent.notifier()))
         return targetChanged;
      return skip;
   };
   virtual void performSetSource()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : RetrieveData(szNostrosLongName) to NostrosLongField(text))");
      ITRACE_DEVELOP(" setting source from target ");
      source->setSzNostrosLongName(target->text());
   };
   virtual void performSetTarget()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : RetrieveData(szNostrosLongName) to NostrosLongField(text))");
      ITRACE_DEVELOP(" setting target from source ");
      target->setText(source->szNostrosLongName());
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   RetrieveData * source;
   IEntryField * target;


};   //MainScreenConn20


//*****************************************************************************
// Class definition for MainScreenConn22
//*****************************************************************************
class MainScreenConn22 : public IVBAttributeConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn22(RetrieveData * aSource, IEntryField * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
      handleNotificationsFor(*target);
   };

   virtual  ~MainScreenConn22()
   {
      stopHandlingNotificationsFor(*source);
      stopHandlingNotificationsFor(*target);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      if ((anEvent.notificationId() == RetrieveData::szISINId) && (source == &anEvent.notifier()))
         return sourceChanged;
      else
      if ((anEvent.notificationId() == IEntryField::textId) && (target == &anEvent.notifier()))
         return targetChanged;
      return skip;
   };
   virtual void performSetSource()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : RetrieveData(szISIN) to ISINField(text))");
      ITRACE_DEVELOP(" setting source from target ");
      source->setSzISIN(target->text());
   };
   virtual void performSetTarget()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : RetrieveData(szISIN) to ISINField(text))");
      ITRACE_DEVELOP(" setting target from source ");
      target->setText(source->szISIN());
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   RetrieveData * source;
   IEntryField * target;


};   //MainScreenConn22


//*****************************************************************************
// Class definition for MainScreenConn23
//*****************************************************************************
class MainScreenConn23 : public IVBAttributeConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn23(RetrieveData * aSource, IEntryField * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
      handleNotificationsFor(*target);
   };

   virtual  ~MainScreenConn23()
   {
      stopHandlingNotificationsFor(*source);
      stopHandlingNotificationsFor(*target);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      if ((anEvent.notificationId() == RetrieveData::szISInumberId) && (source == &anEvent.notifier()))
         return sourceChanged;
      else
      if ((anEvent.notificationId() == IEntryField::textId) && (target == &anEvent.notifier()))
         return targetChanged;
      return skip;
   };
   virtual void performSetSource()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : RetrieveData(szISInumber) to InstrumentNoField(text))");
      ITRACE_DEVELOP(" setting source from target ");
      source->setSzISInumber(target->text());
   };
   virtual void performSetTarget()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : RetrieveData(szISInumber) to InstrumentNoField(text))");
      ITRACE_DEVELOP(" setting target from source ");
      target->setText(source->szISInumber());
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   RetrieveData * source;
   IEntryField * target;


};   //MainScreenConn23


//*****************************************************************************
// Class definition for MainScreenConn24
//*****************************************************************************
class MainScreenConn24 : public IVBAttributeConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn24(RetrieveData * aSource, IEntryField * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
      handleNotificationsFor(*target);
   };

   virtual  ~MainScreenConn24()
   {
      stopHandlingNotificationsFor(*source);
      stopHandlingNotificationsFor(*target);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      if ((anEvent.notificationId() == RetrieveData::szInstrumentNameId) && (source == &anEvent.notifier()))
         return sourceChanged;
      else
      if ((anEvent.notificationId() == IEntryField::textId) && (target == &anEvent.notifier()))
         return targetChanged;
      return skip;
   };
   virtual void performSetSource()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : RetrieveData(szInstrumentName) to InstrumentNameField(text))");
      ITRACE_DEVELOP(" setting source from target ");
      source->setSzInstrumentName(target->text());
   };
   virtual void performSetTarget()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : RetrieveData(szInstrumentName) to InstrumentNameField(text))");
      ITRACE_DEVELOP(" setting target from source ");
      target->setText(source->szInstrumentName());
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   RetrieveData * source;
   IEntryField * target;


};   //MainScreenConn24


//*****************************************************************************
// Class definition for MainScreenConn25
//*****************************************************************************
class MainScreenConn25 : public IVBAttributeConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn25(RetrieveData * aSource, IEntryField * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
      handleNotificationsFor(*target);
   };

   virtual  ~MainScreenConn25()
   {
      stopHandlingNotificationsFor(*source);
      stopHandlingNotificationsFor(*target);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      if ((anEvent.notificationId() == RetrieveData::szPriceId) && (source == &anEvent.notifier()))
         return sourceChanged;
      else
      if ((anEvent.notificationId() == IEntryField::textId) && (target == &anEvent.notifier()))
         return targetChanged;
      return skip;
   };
   virtual void performSetSource()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : RetrieveData(szPrice) to PriceField(text))");
      ITRACE_DEVELOP(" setting source from target ");
      source->setSzPrice(target->text());
   };
   virtual void performSetTarget()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : RetrieveData(szPrice) to PriceField(text))");
      ITRACE_DEVELOP(" setting target from source ");
      target->setText(source->szPrice());
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   RetrieveData * source;
   IEntryField * target;


};   //MainScreenConn25


//*****************************************************************************
// Class definition for MainScreenConn37
//*****************************************************************************
class MainScreenConn37 : public IVBConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn37(IPushButton * aSource, RetrieveData * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
   };

   virtual  ~MainScreenConn37()
   {
      stopHandlingNotificationsFor(*source);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      return ((anEvent.notificationId() == IPushButton::buttonClickId));
   };
   void perform(const INotificationEvent & anEvent)
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : PushButton1(buttonClickEvent) to RetrieveData(RepairData))");
      target->RepairData();
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   IPushButton * source;
   RetrieveData * target;


};   //MainScreenConn37


//*****************************************************************************
// Class definition for MainScreenConn28
//*****************************************************************************
class MainScreenConn28 : public IVBAttributeConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn28(IEntryField * aSource, RetrieveData * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
      handleNotificationsFor(*target);
   };

   virtual  ~MainScreenConn28()
   {
      stopHandlingNotificationsFor(*source);
      stopHandlingNotificationsFor(*target);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      if ((anEvent.notificationId() == RetrieveData::thisSettlementEntryFieldId) && (target == &anEvent.notifier()))
         return targetChanged;
      return skip;
   };
   virtual void performSetSource()
   {   };
   virtual void performSetTarget()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : SettlementDateField(this) to RetrieveData(thisSettlementEntryField))");
      ITRACE_DEVELOP(" setting target from source ");
      target->setThisSettlementEntryField(source);
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   IEntryField * source;
   RetrieveData * target;


};   //MainScreenConn28


//*****************************************************************************
// Class definition for MainScreenConn32
//*****************************************************************************
class MainScreenConn32 : public IVBAttributeConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn32(IEntryField * aSource, RetrieveData * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
      handleNotificationsFor(*target);
   };

   virtual  ~MainScreenConn32()
   {
      stopHandlingNotificationsFor(*source);
      stopHandlingNotificationsFor(*target);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      if ((anEvent.notificationId() == RetrieveData::thisCounterpartyEntryFieldId) && (target == &anEvent.notifier()))
         return targetChanged;
      return skip;
   };
   virtual void performSetSource()
   {   };
   virtual void performSetTarget()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : CounterPartyField(this) to RetrieveData(thisCounterpartyEntryField))");
      ITRACE_DEVELOP(" setting target from source ");
      target->setThisCounterpartyEntryField(source);
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   IEntryField * source;
   RetrieveData * target;


};   //MainScreenConn32


//*****************************************************************************
// Class definition for MainScreenConn33
//*****************************************************************************
class MainScreenConn33 : public IVBAttributeConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn33(IEntryField * aSource, RetrieveData * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
      handleNotificationsFor(*target);
   };

   virtual  ~MainScreenConn33()
   {
      stopHandlingNotificationsFor(*source);
      stopHandlingNotificationsFor(*target);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      if ((anEvent.notificationId() == RetrieveData::thisMarketEntryFieldId) && (target == &anEvent.notifier()))
         return targetChanged;
      return skip;
   };
   virtual void performSetSource()
   {   };
   virtual void performSetTarget()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : MarketField(this) to RetrieveData(thisMarketEntryField))");
      ITRACE_DEVELOP(" setting target from source ");
      target->setThisMarketEntryField(source);
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   IEntryField * source;
   RetrieveData * target;


};   //MainScreenConn33


//*****************************************************************************
// Class definition for MainScreenConn34
//*****************************************************************************
class MainScreenConn34 : public IVBAttributeConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn34(IEntryField * aSource, RetrieveData * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
      handleNotificationsFor(*target);
   };

   virtual  ~MainScreenConn34()
   {
      stopHandlingNotificationsFor(*source);
      stopHandlingNotificationsFor(*target);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      if ((anEvent.notificationId() == RetrieveData::thisBookEntryFieldId) && (target == &anEvent.notifier()))
         return targetChanged;
      return skip;
   };
   virtual void performSetSource()
   {   };
   virtual void performSetTarget()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : BookField(this) to RetrieveData(thisBookEntryField))");
      ITRACE_DEVELOP(" setting target from source ");
      target->setThisBookEntryField(source);
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   IEntryField * source;
   RetrieveData * target;


};   //MainScreenConn34


//*****************************************************************************
// Class definition for MainScreenConn47
//*****************************************************************************
class MainScreenConn47 : public IVBAttributeConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn47(ICanvas * aSource, RetrieveData * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
      handleNotificationsFor(*target);
   };

   virtual  ~MainScreenConn47()
   {
      stopHandlingNotificationsFor(*source);
      stopHandlingNotificationsFor(*target);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      if ((anEvent.notificationId() == RetrieveData::thisMainWindowId) && (target == &anEvent.notifier()))
         return targetChanged;
      return skip;
   };
   virtual void performSetSource()
   {   };
   virtual void performSetTarget()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : Canvas(this) to RetrieveData(thisMainWindow))");
      ITRACE_DEVELOP(" setting target from source ");
      target->setThisMainWindow(source);
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   ICanvas * source;
   RetrieveData * target;


};   //MainScreenConn47


//*****************************************************************************
// Class definition for MainScreenConn57
//*****************************************************************************
class MainScreenConn57 : public IVBAttributeConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn57(IBitmapControl * aSource, RetrieveData * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
      handleNotificationsFor(*target);
   };

   virtual  ~MainScreenConn57()
   {
      stopHandlingNotificationsFor(*source);
      stopHandlingNotificationsFor(*target);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      if ((anEvent.notificationId() == RetrieveData::thisBitmapId) && (target == &anEvent.notifier()))
         return targetChanged;
      return skip;
   };
   virtual void performSetSource()
   {   };
   virtual void performSetTarget()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : BitmapControl1(this) to RetrieveData(thisBitmap))");
      ITRACE_DEVELOP(" setting target from source ");
      target->setThisBitmap(source);
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   IBitmapControl * source;
   RetrieveData * target;


};   //MainScreenConn57


//*****************************************************************************
// Class definition for MainScreenConn67
//*****************************************************************************
class MainScreenConn67 : public IVBConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn67(ICanvas * aSource, IVBFlyText * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
   };

   virtual  ~MainScreenConn67()
   {
      stopHandlingNotificationsFor(*source);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      return true;
   };
   void perform(const INotificationEvent & anEvent)
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : Canvas(anyEvent) to VBFlyText(flyOverHelp))");
      target->enableFlyOverHelp();
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   ICanvas * source;
   IVBFlyText * target;


};   //MainScreenConn67


//*****************************************************************************
// Class definition for MainScreenConn43
//*****************************************************************************
class MainScreenConn43 : public IVBConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn43(IPushButton * aSource, IPushButton * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
   };

   virtual  ~MainScreenConn43()
   {
      stopHandlingNotificationsFor(*source);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      return ((anEvent.notificationId() == IPushButton::buttonClickId));
   };
   void perform(const INotificationEvent & anEvent)
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : PushButton1(buttonClickEvent) to PushButton1(disable))");
      target->disable();
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   IPushButton * source;
   IPushButton * target;


};   //MainScreenConn43


const INotificationId _Export MainScreen::readyId = "MainScreen::readyId";

//------------------------------------------------------------------------------
// MainScreen :: defaultFramingSpec
//------------------------------------------------------------------------------
const IRectangle _Export MainScreen::defaultFramingSpec()
{
   return(IRectangle(VBPOINT(0, IWindow::desktopWindow()->size().height() - -1 - 651, 0, -1), ISize(573, 651)));
}

//------------------------------------------------------------------------------
// MainScreen :: defaultStyle
//------------------------------------------------------------------------------
const IFrameWindow::Style _Export MainScreen::defaultStyle()
{
   return(IFrameWindow::defaultStyle());
}

//------------------------------------------------------------------------------
// MainScreen :: defaultTitle
//------------------------------------------------------------------------------
IString _Export MainScreen::defaultTitle()
{
   return("Straight Through Processing - [Trade Screen]   Repair Screen");
}

//------------------------------------------------------------------------------
// MainScreen :: MainScreen
//------------------------------------------------------------------------------
_Export MainScreen::MainScreen(
      unsigned long id, 
      IWindow* parent, 
      IWindow* owner, 
      const IRectangle& rect, 
      const IFrameWindow::Style& style, 
      const char* title)
   : IFrameWindow(id, parent, owner, rect, style, title)
{
   iMainScreenConnectionList = new IVBConnectionList;

   iCanvas = new ICanvas(
      IC_FRAME_CLIENT_ID, 
      this, 
      this, 
      IRectangle(), 
      ICanvas::defaultStyle() | IWindow::synchPaint);
   iStaticText12 = new IStaticText(
      id+WNDOFFSET_MainScreen_StaticText12, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(34, 572, 34, 38), ISize(73, 14)));
   iCounterPartyField = new IEntryField(
      id+WNDOFFSET_MainScreen_CounterPartyField, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(35, 545, 35, 58), ISize(80, 21)));
   iStaticText13 = new IStaticText(
      id+WNDOFFSET_MainScreen_StaticText13, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(151, 572, 151, 38), ISize(63, 14)));
   iInternalRef = new IEntryField(
      id+WNDOFFSET_MainScreen_InternalRef, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(150, 545, 150, 57), ISize(81, 22)));
   iStaticText14 = new IStaticText(
      id+WNDOFFSET_MainScreen_StaticText14, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(261, 572, 261, 38), ISize(65, 14)));
   iExternalRefField = new IEntryField(
      id+WNDOFFSET_MainScreen_ExternalRefField, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(259, 545, 259, 58), ISize(97, 21)));
   iStaticText15 = new IStaticText(
      id+WNDOFFSET_MainScreen_StaticText15, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(61, 514, 61, 96), ISize(62, 14)));
   iISINField = new IEntryField(
      id+WNDOFFSET_MainScreen_ISINField, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(40, 482, 40, 119), ISize(42, 23)));
   iInstrumentNoField = new IEntryField(
      id+WNDOFFSET_MainScreen_InstrumentNoField, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(103, 483, 103, 119), ISize(75, 22)));
   iInstrumentNameField = new IEntryField(
      id+WNDOFFSET_MainScreen_InstrumentNameField, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(204, 483, 204, 120), ISize(263, 21)));
   iStaticText16 = new IStaticText(
      id+WNDOFFSET_MainScreen_StaticText16, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(209, 514, 209, 97), ISize(96, 13)));
   iStaticText17 = new IStaticText(
      id+WNDOFFSET_MainScreen_StaticText17, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(41, 448, 41, 162), ISize(43, 14)));
   iBuySellField = new IEntryField(
      id+WNDOFFSET_MainScreen_BuySellField, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(34, 421, 34, 183), ISize(65, 20)));
   iStaticText18 = new IStaticText(
      id+WNDOFFSET_MainScreen_StaticText18, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(115, 448, 115, 162), ISize(18, 14)));
   iQtyField = new IEntryField(
      id+WNDOFFSET_MainScreen_QtyField, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(111, 421, 111, 182), ISize(28, 21)));
   iStaticText19 = new IStaticText(
      id+WNDOFFSET_MainScreen_StaticText19, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(235, 448, 235, 162), ISize(51, 14)));
   iCurrencyField = new IEntryField(
      id+WNDOFFSET_MainScreen_CurrencyField, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(226, 421, 226, 181), ISize(93, 22)));
   iStaticText20 = new IStaticText(
      id+WNDOFFSET_MainScreen_StaticText20, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(330, 448, 330, 162), ISize(109, 14)));
   iConsiderationField = new IEntryField(
      id+WNDOFFSET_MainScreen_ConsiderationField, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(334, 421, 334, 181), ISize(116, 22)));
   iStaticText21 = new IStaticText(
      id+WNDOFFSET_MainScreen_StaticText21, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(467, 448, 467, 162), ISize(35, 14)));
   iStatusField = new IEntryField(
      id+WNDOFFSET_MainScreen_StatusField, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(464, 420, 464, 181), ISize(66, 23)));
   iStaticText1 = new IStaticText(
      id+WNDOFFSET_MainScreen_StaticText1, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(40, 337, 40, 273), ISize(62, 14)));
   iTradeTypeField = new IEntryField(
      id+WNDOFFSET_MainScreen_TradeTypeField, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(39, 308, 39, 295), ISize(81, 21)));
   iStaticText2 = new IStaticText(
      id+WNDOFFSET_MainScreen_StaticText2, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(145, 337, 145, 273), ISize(28, 14)));
   iBookField = new IEntryField(
      id+WNDOFFSET_MainScreen_BookField, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(141, 309, 141, 293), ISize(64, 22)));
   iStaticText3 = new IStaticText(
      id+WNDOFFSET_MainScreen_StaticText3, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(232, 338, 232, 272), ISize(39, 14)));
   iMarketField = new IEntryField(
      id+WNDOFFSET_MainScreen_MarketField, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(229, 311, 229, 292), ISize(73, 21)));
   iStaticText4 = new IStaticText(
      id+WNDOFFSET_MainScreen_StaticText4, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(40, 278, 40, 332), ISize(91, 14)));
   iSettlementTypeField = new IEntryField(
      id+WNDOFFSET_MainScreen_SettlementTypeField, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(39, 251, 39, 350), ISize(268, 23)));
   iStaticText5 = new IStaticText(
      id+WNDOFFSET_MainScreen_StaticText5, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(339, 280, 339, 330), ISize(81, 14)));
   iMessageTypeField = new IEntryField(
      id+WNDOFFSET_MainScreen_MessageTypeField, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(336, 252, 336, 349), ISize(114, 23)));
   iStaticText6 = new IStaticText(
      id+WNDOFFSET_MainScreen_StaticText6, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(43, 213, 43, 397), ISize(59, 14)));
   iTradeDateField = new IEntryField(
      id+WNDOFFSET_MainScreen_TradeDateField, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(42, 185, 42, 418), ISize(79, 21)));
   iStaticText7 = new IStaticText(
      id+WNDOFFSET_MainScreen_StaticText7, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(149, 213, 149, 397), ISize(63, 14)));
   iTradeTimeField = new IEntryField(
      id+WNDOFFSET_MainScreen_TradeTimeField, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(148, 186, 148, 416), ISize(79, 22)));
   iStaticText8 = new IStaticText(
      id+WNDOFFSET_MainScreen_StaticText8, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(255, 213, 255, 397), ISize(88, 14)));
   iSettlementDateField = new IEntryField(
      id+WNDOFFSET_MainScreen_SettlementDateField, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(255, 188, 255, 415), ISize(97, 21)));
   iPushButton1 = new IPushButton(
      id+WNDOFFSET_MainScreen_PushButton1, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(131, 18, 131, 586), ISize(88, 20)));
   iStaticText11 = new IStaticText(
      id+WNDOFFSET_MainScreen_StaticText11, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(46, 149, 46, 461), ISize(32, 14)));
   iDepotShortField = new IEntryField(
      id+WNDOFFSET_MainScreen_DepotShortField, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(43, 125, 43, 478), ISize(95, 21)));
   iDepotLongField = new IEntryField(
      id+WNDOFFSET_MainScreen_DepotLongField, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(147, 125, 147, 478), ISize(273, 21)));
   iStaticText9 = new IStaticText(
      id+WNDOFFSET_MainScreen_StaticText9, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(44, 98, 44, 512), ISize(44, 14)));
   iNostrosShortField = new IEntryField(
      id+WNDOFFSET_MainScreen_NostrosShortField, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(43, 72, 43, 530), ISize(89, 22)));
   iNostrosLongField = new IEntryField(
      id+WNDOFFSET_MainScreen_NostrosLongField, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(148, 72, 148, 530), ISize(272, 22)));
   iPushButton2 = new IPushButton(
      id+WNDOFFSET_MainScreen_PushButton2, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(248, 17, 248, 585), ISize(59, 22)));
   iStaticText10 = new IStaticText(
      id+WNDOFFSET_MainScreen_StaticText10, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(153, 448, 153, 161), ISize(33, 15)));
   iPriceField = new IEntryField(
      id+WNDOFFSET_MainScreen_PriceField, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(152, 421, 152, 183), ISize(60, 20)));
   iEditBoxMQMessage = new IEntryField(
      id+WNDOFFSET_MainScreen_EditBoxMQMessage, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(446, 17, 446, 584), ISize(101, 23)), 
      IEntryField::defaultStyle() & ~IWindow::visible);
   iBitmapControl1 = new IBitmapControl(
      id+WNDOFFSET_MainScreen_BitmapControl1, 
      iCanvas, 
      iCanvas, 
      IBitmapHandle (), 
      IRectangle(VBPOINT(1, 593, 1, -1), ISize(42, 32)), 
      IBitmapControl::defaultStyle() | IBitmapControl::sizeToBitmap | IWindow::clipSiblings | IWindow::synchPaint);
   iRetrieveData = new RetrieveData();
   iVBFlyText = new IVBFlyText(this);

   iStaticText12->setFont(IFont("Arial", 8).setBold(true).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText12->setText("CounterParty");
   iCounterPartyField->setText("HSAMLN");
   iCounterPartyField->setFont(IFont("Arial", 8).setBold(false).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText13->setFont(IFont("Arial", 8).setBold(true).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText13->setText("Internal Ref");
   iInternalRef->setText("100123");
   iInternalRef->setFont(IFont("Arial", 8).setBold(false).setItalic(false).setUnderscore(false).setStrikeout(false));
   iInternalRef->setForegroundColor(IColor(IColor::black));
   iStaticText14->setFont(IFont("Arial", 8).setBold(true).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText14->setText("External Ref");
   iExternalRefField->setText("200234");
   iExternalRefField->setFont(IFont("Arial", 8).setBold(false).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText15->setFont(IFont("Arial", 8).setBold(true).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText15->setText("Instrument");
   iISINField->setText("ISIN");
   iISINField->setFont(IFont("Arial", 8).setBold(false).setItalic(false).setUnderscore(false).setStrikeout(false));
   iInstrumentNoField->setText("GB007908733");
   iInstrumentNoField->setFont(IFont("Arial", 8).setBold(false).setItalic(false).setUnderscore(false).setStrikeout(false));
   iInstrumentNameField->setLimit(70);
   iInstrumentNameField->setText("SCOTTISH & SOUTHERLY HILL SAMUEL ASSET MG");
   iInstrumentNameField->setFont(IFont("Arial", 8).setBold(false).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText16->setFont(IFont("Arial", 8).setBold(true).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText16->setText("Instrument Name");
   iStaticText17->setFont(IFont("Arial", 8).setBold(true).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText17->setText("Buy/Sell");
   iBuySellField->setText("SELL");
   iBuySellField->setFont(IFont("Arial", 8).setBold(false).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText18->setFont(IFont("Arial", 8).setBold(true).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText18->setText("Qty");
   iQtyField->setText("22");
   iQtyField->setFont(IFont("Arial", 8).setBold(false).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText19->setFont(IFont("Arial", 8).setBold(true).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText19->setText("Currency");
   iCurrencyField->setText("GBP");
   iCurrencyField->setFont(IFont("Arial", 8).setBold(false).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText20->setFont(IFont("Arial", 8).setBold(true).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText20->setText("Consideration (NET)");
   iConsiderationField->setText("374000");
   iConsiderationField->setFont(IFont("Arial", 8).setBold(false).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText21->setFont(IFont("Arial", 8).setBold(true).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText21->setText("Status");
   iStatusField->setText("AMENDING");
   iStatusField->setFont(IFont("Arial", 8).setBold(false).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText1->setFont(IFont("Arial", 8).setBold(true).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText1->setText("Trade Type");
   iTradeTypeField->setText("PRINCIPAL");
   iTradeTypeField->setFont(IFont("Arial", 8).setBold(false).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText2->setFont(IFont("Arial", 8).setBold(true).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText2->setText("Book");
   iBookField->setText("LNEBST2");
   iBookField->setFont(IFont("Arial", 8).setBold(false).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText3->setFont(IFont("Arial", 8).setBold(true).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText3->setText("Market");
   iMarketField->setText("UK");
   iMarketField->setFont(IFont("Arial", 8).setBold(false).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText4->setFont(IFont("Arial", 8).setBold(true).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText4->setText("Settlement Type");
   iSettlementTypeField->setText("CASH ON DELIVERY");
   iSettlementTypeField->setFont(IFont("Arial", 8).setBold(false).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText5->setFont(IFont("Arial", 8).setBold(true).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText5->setText("Message Type");
   iMessageTypeField->setText("FAX");
   iMessageTypeField->setFont(IFont("Arial", 8).setBold(false).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText6->setFont(IFont("Arial", 8).setBold(true).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText6->setText("Trade Date");
   iTradeDateField->setText("05/08/99");
   iTradeDateField->setFont(IFont("Arial", 8).setBold(false).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText7->setFont(IFont("Arial", 8).setBold(true).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText7->setText("Trade Time");
   iTradeTimeField->setText("12:32");
   iTradeTimeField->setFont(IFont("Arial", 8).setBold(false).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText8->setFont(IFont("Arial", 8).setBold(true).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText8->setText("Settlement Date");
   iSettlementDateField->setText("12/08/99");
   iSettlementDateField->setFont(IFont("Arial", 8).setBold(false).setItalic(false).setUnderscore(false).setStrikeout(false));
   iPushButton1->setFont(IFont("Arial", 8).setBold(true).setItalic(false).setUnderscore(false).setStrikeout(false));
   iPushButton1->setText("Repair Data");
   iPushButton1->setForegroundColor(IColor(IColor::darkBlue));
   iStaticText11->setFont(IFont("Arial", 8).setBold(true).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText11->setText("Depot");
   iDepotShortField->setText("OURS OCITILON");
   iDepotShortField->setFont(IFont("Arial", 8).setBold(false).setItalic(false).setUnderscore(false).setStrikeout(false));
   iDepotLongField->setLimit(60);
   iDepotLongField->setText("OUR CITIBANK NA - LO CRSP CITIBANK NA LONDON");
   iDepotLongField->setFont(IFont("Arial", 8).setBold(false).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText9->setFont(IFont("Arial", 8).setBold(true).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText9->setText("Nostros");
   iNostrosShortField->setText("OURS OCITILON");
   iNostrosShortField->setFont(IFont("Arial", 8).setBold(false).setItalic(false).setUnderscore(false).setStrikeout(false));
   iNostrosLongField->setLimit(60);
   iNostrosLongField->setText("OUR CITIBANK NA - LO CRSP CITIBANK NA LONDON");
   iNostrosLongField->setFont(IFont("Arial", 8).setBold(false).setItalic(false).setUnderscore(false).setStrikeout(false));
   iPushButton2->setFont(IFont("Arial", 8).setBold(true).setItalic(false).setUnderscore(false).setStrikeout(false));
   iPushButton2->setText("Continue");
   iStaticText10->setFont(IFont("Arial", 8).setBold(true).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText10->setText("Price");
   iPriceField->setText("17000");
   iPriceField->setFont(IFont("Arial", 8).setBold(false).setItalic(false).setUnderscore(false).setStrikeout(false));
   iEditBoxMQMessage->setText("STP_QUEUE");
   this->setClient(iCanvas);
   this->setBackgroundColor(IColor(IColor::paleGray));
   this->setFocus();
   IFlyOverHelpHandler * iVBFlyTextHandler = iVBFlyText->flyOverHelpHandler();
   iVBFlyTextHandler->setHelpText(iStaticText12->handle(), "A client that is buying/selling shares from member firm of Stock Exchange. ", "");
   iVBFlyTextHandler->setHelpText(iStaticText13->handle(), "The internal reference number associated with this trade.", "");
   iVBFlyTextHandler->setHelpText(iStaticText14->handle(), "The external reference number associated with this trade.", "");
   iVBFlyTextHandler->setHelpText(iStaticText15->handle(), "A Securities Identification Number unique to each security.", "");
   iVBFlyTextHandler->setHelpText(iISINField->handle(), "A Securities Identification Number unique to each security.", "");
   iVBFlyTextHandler->setHelpText(iInstrumentNoField->handle(), "A Securities Identification Number unique to each security.", "");
   iVBFlyTextHandler->setHelpText(iStaticText16->handle(), "The name of the company issuing the share.", "");
   iVBFlyTextHandler->setHelpText(iStaticText17->handle(), "Buying or selling shares.", "");
   iVBFlyTextHandler->setHelpText(iStaticText18->handle(), "Number of shares being traded", "");
   iVBFlyTextHandler->setHelpText(iStaticText19->handle(), "The currency in which the shares are valued in.", "");
   iVBFlyTextHandler->setHelpText(iStaticText20->handle(), "Cost of shares derived from number of shares x share price.", "");
   iVBFlyTextHandler->setHelpText(iStaticText21->handle(), "The status of the trade.", "");
   iVBFlyTextHandler->setHelpText(iStaticText1->handle(), "Firm sells/buys shares from/to its own portfolio of holding", "");
   iVBFlyTextHandler->setHelpText(iStaticText2->handle(), "A firms accounting book that holds the entry that symbolises the share holding.", "");
   iVBFlyTextHandler->setHelpText(iStaticText3->handle(), "The nation on whose exchange the security is traded.", "");
   iVBFlyTextHandler->setHelpText(iStaticText4->handle(), "Method of payment, ie. Delivery Vs Payment, Cash on Delivery.", "");
   iVBFlyTextHandler->setHelpText(iStaticText5->handle(), "The type of confirmation medium required by Trader.", "");
   iVBFlyTextHandler->setHelpText(iStaticText6->handle(), "Date that the deal is inputted by the trader.", "");
   iVBFlyTextHandler->setHelpText(iStaticText7->handle(), "The time the trade was inputted by the trader.", "");
   iVBFlyTextHandler->setHelpText(iStaticText8->handle(), "Date that the deal is due to settle.", "");
   iVBFlyTextHandler->setHelpText(iStaticText11->handle(), "Place where a companies shares are held, ie. a custodian bank.", "");
   iVBFlyTextHandler->setHelpText(iStaticText9->handle(), "Bank holding the currency account.", "");
   iVBFlyTextHandler->setHelpText(iStaticText10->handle(), "Market price per share.", "");
}     //end constructor

//------------------------------------------------------------------------------
// MainScreen :: ~MainScreen
//------------------------------------------------------------------------------
_Export MainScreen::~MainScreen()
{
   delete iMainScreenConnectionList;

   delete iVBFlyText;
   delete iRetrieveData;
   delete iBitmapControl1;
   delete iEditBoxMQMessage;
   delete iPriceField;
   delete iStaticText10;
   delete iPushButton2;
   delete iNostrosLongField;
   delete iNostrosShortField;
   delete iStaticText9;
   delete iDepotLongField;
   delete iDepotShortField;
   delete iStaticText11;
   delete iPushButton1;
   delete iSettlementDateField;
   delete iStaticText8;
   delete iTradeTimeField;
   delete iStaticText7;
   delete iTradeDateField;
   delete iStaticText6;
   delete iMessageTypeField;
   delete iStaticText5;
   delete iSettlementTypeField;
   delete iStaticText4;
   delete iMarketField;
   delete iStaticText3;
   delete iBookField;
   delete iStaticText2;
   delete iTradeTypeField;
   delete iStaticText1;
   delete iStatusField;
   delete iStaticText21;
   delete iConsiderationField;
   delete iStaticText20;
   delete iCurrencyField;
   delete iStaticText19;
   delete iQtyField;
   delete iStaticText18;
   delete iBuySellField;
   delete iStaticText17;
   delete iStaticText16;
   delete iInstrumentNameField;
   delete iInstrumentNoField;
   delete iISINField;
   delete iStaticText15;
   delete iExternalRefField;
   delete iStaticText14;
   delete iInternalRef;
   delete iStaticText13;
   delete iCounterPartyField;
   delete iStaticText12;
   delete iCanvas;
}

//------------------------------------------------------------------------------
// MainScreen :: initializePart
//------------------------------------------------------------------------------
MainScreen & _Export MainScreen::initializePart()
{
   makeConnections();
   notifyObservers(INotificationEvent(readyId, *this));
   return *this;
}

//------------------------------------------------------------------------------
// MainScreen :: makeConnections
//------------------------------------------------------------------------------
void _Export MainScreen::makeConnections()
{
   this->enableNotification();
   iCanvas->enableNotification();
   iStaticText12->enableNotification();
   iCounterPartyField->enableNotification();
   iStaticText13->enableNotification();
   iInternalRef->enableNotification();
   iStaticText14->enableNotification();
   iExternalRefField->enableNotification();
   iStaticText15->enableNotification();
   iISINField->enableNotification();
   iInstrumentNoField->enableNotification();
   iInstrumentNameField->enableNotification();
   iStaticText16->enableNotification();
   iStaticText17->enableNotification();
   iBuySellField->enableNotification();
   iStaticText18->enableNotification();
   iQtyField->enableNotification();
   iStaticText19->enableNotification();
   iCurrencyField->enableNotification();
   iStaticText20->enableNotification();
   iConsiderationField->enableNotification();
   iStaticText21->enableNotification();
   iStatusField->enableNotification();
   iStaticText1->enableNotification();
   iTradeTypeField->enableNotification();
   iStaticText2->enableNotification();
   iBookField->enableNotification();
   iStaticText3->enableNotification();
   iMarketField->enableNotification();
   iStaticText4->enableNotification();
   iSettlementTypeField->enableNotification();
   iStaticText5->enableNotification();
   iMessageTypeField->enableNotification();
   iStaticText6->enableNotification();
   iTradeDateField->enableNotification();
   iStaticText7->enableNotification();
   iTradeTimeField->enableNotification();
   iStaticText8->enableNotification();
   iSettlementDateField->enableNotification();
   iPushButton1->enableNotification();
   iStaticText11->enableNotification();
   iDepotShortField->enableNotification();
   iDepotLongField->enableNotification();
   iStaticText9->enableNotification();
   iNostrosShortField->enableNotification();
   iNostrosLongField->enableNotification();
   iPushButton2->enableNotification();
   iStaticText10->enableNotification();
   iPriceField->enableNotification();
   iEditBoxMQMessage->enableNotification();
   iBitmapControl1->enableNotification();
   iRetrieveData->enableNotification();
   iVBFlyText->enableNotification();

   unsigned long id = this->id();
   MainScreenConn0 *conn0 = new MainScreenConn0(iPushButton2, this);
   iMainScreenConnectionList->add(conn0);
   MainScreenConn1 *conn1 = new MainScreenConn1(iRetrieveData, iCounterPartyField);
   iMainScreenConnectionList->add(conn1);
   MainScreenConn2 *conn2 = new MainScreenConn2(iRetrieveData, iInternalRef);
   iMainScreenConnectionList->add(conn2);
   MainScreenConn3 *conn3 = new MainScreenConn3(iRetrieveData, iExternalRefField);
   iMainScreenConnectionList->add(conn3);
   MainScreenConn4 *conn4 = new MainScreenConn4(iRetrieveData, iQtyField);
   iMainScreenConnectionList->add(conn4);
   MainScreenConn5 *conn5 = new MainScreenConn5(iRetrieveData, iBuySellField);
   iMainScreenConnectionList->add(conn5);
   MainScreenConn6 *conn6 = new MainScreenConn6(iRetrieveData, iSettlementDateField);
   iMainScreenConnectionList->add(conn6);
   MainScreenConn7 *conn7 = new MainScreenConn7(iRetrieveData, iSettlementTypeField);
   iMainScreenConnectionList->add(conn7);
   MainScreenConn8 *conn8 = new MainScreenConn8(iRetrieveData, iCurrencyField);
   iMainScreenConnectionList->add(conn8);
   MainScreenConn9 *conn9 = new MainScreenConn9(iRetrieveData, iConsiderationField);
   iMainScreenConnectionList->add(conn9);
   MainScreenConn10 *conn10 = new MainScreenConn10(iRetrieveData, iStatusField);
   iMainScreenConnectionList->add(conn10);
   MainScreenConn11 *conn11 = new MainScreenConn11(iRetrieveData, iTradeTypeField);
   iMainScreenConnectionList->add(conn11);
   MainScreenConn12 *conn12 = new MainScreenConn12(iRetrieveData, iBookField);
   iMainScreenConnectionList->add(conn12);
   MainScreenConn13 *conn13 = new MainScreenConn13(iRetrieveData, iMarketField);
   iMainScreenConnectionList->add(conn13);
   MainScreenConn14 *conn14 = new MainScreenConn14(iRetrieveData, iMessageTypeField);
   iMainScreenConnectionList->add(conn14);
   MainScreenConn15 *conn15 = new MainScreenConn15(iRetrieveData, iTradeDateField);
   iMainScreenConnectionList->add(conn15);
   MainScreenConn16 *conn16 = new MainScreenConn16(iRetrieveData, iTradeTimeField);
   iMainScreenConnectionList->add(conn16);
   MainScreenConn17 *conn17 = new MainScreenConn17(iRetrieveData, iDepotShortField);
   iMainScreenConnectionList->add(conn17);
   MainScreenConn18 *conn18 = new MainScreenConn18(iRetrieveData, iDepotLongField);
   iMainScreenConnectionList->add(conn18);
   MainScreenConn19 *conn19 = new MainScreenConn19(iRetrieveData, iNostrosShortField);
   iMainScreenConnectionList->add(conn19);
   MainScreenConn20 *conn20 = new MainScreenConn20(iRetrieveData, iNostrosLongField);
   iMainScreenConnectionList->add(conn20);
   MainScreenConn22 *conn22 = new MainScreenConn22(iRetrieveData, iISINField);
   iMainScreenConnectionList->add(conn22);
   MainScreenConn23 *conn23 = new MainScreenConn23(iRetrieveData, iInstrumentNoField);
   iMainScreenConnectionList->add(conn23);
   MainScreenConn24 *conn24 = new MainScreenConn24(iRetrieveData, iInstrumentNameField);
   iMainScreenConnectionList->add(conn24);
   MainScreenConn25 *conn25 = new MainScreenConn25(iRetrieveData, iPriceField);
   iMainScreenConnectionList->add(conn25);
   MainScreenConn37 *conn37 = new MainScreenConn37(iPushButton1, iRetrieveData);
   iMainScreenConnectionList->add(conn37);
   MainScreenConn28 *conn28 = new MainScreenConn28(iSettlementDateField, iRetrieveData);
   iMainScreenConnectionList->add(conn28);
   MainScreenConn32 *conn32 = new MainScreenConn32(iCounterPartyField, iRetrieveData);
   iMainScreenConnectionList->add(conn32);
   MainScreenConn33 *conn33 = new MainScreenConn33(iMarketField, iRetrieveData);
   iMainScreenConnectionList->add(conn33);
   MainScreenConn34 *conn34 = new MainScreenConn34(iBookField, iRetrieveData);
   iMainScreenConnectionList->add(conn34);
   MainScreenConn47 *conn47 = new MainScreenConn47(iCanvas, iRetrieveData);
   iMainScreenConnectionList->add(conn47);
   MainScreenConn57 *conn57 = new MainScreenConn57(iBitmapControl1, iRetrieveData);
   iMainScreenConnectionList->add(conn57);
   MainScreenConn67 *conn67 = new MainScreenConn67(iCanvas, iVBFlyText);
   iMainScreenConnectionList->add(conn67);
   MainScreenConn43 *conn43 = new MainScreenConn43(iPushButton1, iPushButton1);
   iMainScreenConnectionList->add(conn43);


   iMainScreenConnectionList->initialize();
}


