/*******************************************************************************
* FILE NAME: MnScreen.cpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   Class implementation of the class:                                         *
*     MainScreen- This is the main STP screen                                  *
* ---------------------------------------------------------------------------- *
* Warning: This file was generated by the VisualAge C++ Visual Builder.        *
* Modifications to this source file will be lost when the part is regenerated. *
*******************************************************************************/
#include <iframe.hpp>
#include <icolor.hpp>
#include <icanvas.hpp>
#include <istattxt.hpp>
#include <ifont.hpp>
#include <irect.hpp>
#include <ipoint.hpp>
#include <ientryfd.hpp>
#include <ipushbut.hpp>
#include <ibmpctl.hpp>
#include "CmplrDta.hpp"
#include <ivbfly.hpp>
#include <iflyhhdr.hpp>
#include <inotifev.hpp>
#include <ivbconn.hpp>
#include "MnScreen.hpp"
#include <ivbmnstr.hpp>
#include <icoordsy.hpp>
#include <itrace.hpp>

//*****************************************************************************
// Class definition for MainScreenConn0
//*****************************************************************************
class MainScreenConn0 : public IVBConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn0(IPushButton * aSource, IFrameWindow * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
   };

   virtual  ~MainScreenConn0()
   {
      stopHandlingNotificationsFor(*source);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      return ((anEvent.notificationId() == IPushButton::buttonClickId));
   };
   void perform(const INotificationEvent & anEvent)
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : PushButton2(buttonClickEvent) to FrameWindow(close))");
      target->close();
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   IPushButton * source;
   IFrameWindow * target;


};   //MainScreenConn0


//*****************************************************************************
// Class definition for MainScreenConn1
//*****************************************************************************
class MainScreenConn1 : public IVBAttributeConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn1(IEntryField * aSource, CompilerData * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
      handleNotificationsFor(*target);
   };

   virtual  ~MainScreenConn1()
   {
      stopHandlingNotificationsFor(*source);
      stopHandlingNotificationsFor(*target);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      if ((anEvent.notificationId() == IEntryField::textId) && (source == &anEvent.notifier()))
         return sourceChanged;
      else
      if ((anEvent.notificationId() == CompilerData::szCounterpartyId) && (target == &anEvent.notifier()))
         return targetChanged;
      return skip;
   };
   virtual void performSetSource()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : CounterPartyField(text) to CompilerData(szCounterparty))");
      ITRACE_DEVELOP(" setting source from target ");
      source->setText(target->szCounterparty());
   };
   virtual void performSetTarget()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : CounterPartyField(text) to CompilerData(szCounterparty))");
      ITRACE_DEVELOP(" setting target from source ");
      target->setSzCounterparty(source->text());
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   IEntryField * source;
   CompilerData * target;


};   //MainScreenConn1


//*****************************************************************************
// Class definition for MainScreenConn2
//*****************************************************************************
class MainScreenConn2 : public IVBAttributeConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn2(IEntryField * aSource, CompilerData * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
      handleNotificationsFor(*target);
   };

   virtual  ~MainScreenConn2()
   {
      stopHandlingNotificationsFor(*source);
      stopHandlingNotificationsFor(*target);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      if ((anEvent.notificationId() == IEntryField::textId) && (source == &anEvent.notifier()))
         return sourceChanged;
      else
      if ((anEvent.notificationId() == CompilerData::szInternalRefId) && (target == &anEvent.notifier()))
         return targetChanged;
      return skip;
   };
   virtual void performSetSource()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : InternalRef(text) to CompilerData(szInternalRef))");
      ITRACE_DEVELOP(" setting source from target ");
      source->setText(target->szInternalRef());
   };
   virtual void performSetTarget()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : InternalRef(text) to CompilerData(szInternalRef))");
      ITRACE_DEVELOP(" setting target from source ");
      target->setSzInternalRef(source->text());
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   IEntryField * source;
   CompilerData * target;


};   //MainScreenConn2


//*****************************************************************************
// Class definition for MainScreenConn3
//*****************************************************************************
class MainScreenConn3 : public IVBAttributeConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn3(IEntryField * aSource, CompilerData * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
      handleNotificationsFor(*target);
   };

   virtual  ~MainScreenConn3()
   {
      stopHandlingNotificationsFor(*source);
      stopHandlingNotificationsFor(*target);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      if ((anEvent.notificationId() == IEntryField::textId) && (source == &anEvent.notifier()))
         return sourceChanged;
      else
      if ((anEvent.notificationId() == CompilerData::szExternalRefId) && (target == &anEvent.notifier()))
         return targetChanged;
      return skip;
   };
   virtual void performSetSource()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : ExternalRefField(text) to CompilerData(szExternalRef))");
      ITRACE_DEVELOP(" setting source from target ");
      source->setText(target->szExternalRef());
   };
   virtual void performSetTarget()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : ExternalRefField(text) to CompilerData(szExternalRef))");
      ITRACE_DEVELOP(" setting target from source ");
      target->setSzExternalRef(source->text());
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   IEntryField * source;
   CompilerData * target;


};   //MainScreenConn3


//*****************************************************************************
// Class definition for MainScreenConn4
//*****************************************************************************
class MainScreenConn4 : public IVBAttributeConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn4(IEntryField * aSource, CompilerData * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
      handleNotificationsFor(*target);
   };

   virtual  ~MainScreenConn4()
   {
      stopHandlingNotificationsFor(*source);
      stopHandlingNotificationsFor(*target);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      if ((anEvent.notificationId() == IEntryField::textId) && (source == &anEvent.notifier()))
         return sourceChanged;
      else
      if ((anEvent.notificationId() == CompilerData::szISINId) && (target == &anEvent.notifier()))
         return targetChanged;
      return skip;
   };
   virtual void performSetSource()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : ISINField(text) to CompilerData(szISIN))");
      ITRACE_DEVELOP(" setting source from target ");
      source->setText(target->szISIN());
   };
   virtual void performSetTarget()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : ISINField(text) to CompilerData(szISIN))");
      ITRACE_DEVELOP(" setting target from source ");
      target->setSzISIN(source->text());
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   IEntryField * source;
   CompilerData * target;


};   //MainScreenConn4


//*****************************************************************************
// Class definition for MainScreenConn5
//*****************************************************************************
class MainScreenConn5 : public IVBAttributeConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn5(IEntryField * aSource, CompilerData * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
      handleNotificationsFor(*target);
   };

   virtual  ~MainScreenConn5()
   {
      stopHandlingNotificationsFor(*source);
      stopHandlingNotificationsFor(*target);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      if ((anEvent.notificationId() == IEntryField::textId) && (source == &anEvent.notifier()))
         return sourceChanged;
      else
      if ((anEvent.notificationId() == CompilerData::szISINnumberId) && (target == &anEvent.notifier()))
         return targetChanged;
      return skip;
   };
   virtual void performSetSource()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : InstrumentNoField(text) to CompilerData(szISINnumber))");
      ITRACE_DEVELOP(" setting source from target ");
      source->setText(target->szISINnumber());
   };
   virtual void performSetTarget()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : InstrumentNoField(text) to CompilerData(szISINnumber))");
      ITRACE_DEVELOP(" setting target from source ");
      target->setSzISINnumber(source->text());
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   IEntryField * source;
   CompilerData * target;


};   //MainScreenConn5


//*****************************************************************************
// Class definition for MainScreenConn6
//*****************************************************************************
class MainScreenConn6 : public IVBAttributeConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn6(IEntryField * aSource, CompilerData * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
      handleNotificationsFor(*target);
   };

   virtual  ~MainScreenConn6()
   {
      stopHandlingNotificationsFor(*source);
      stopHandlingNotificationsFor(*target);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      if ((anEvent.notificationId() == IEntryField::textId) && (source == &anEvent.notifier()))
         return sourceChanged;
      else
      if ((anEvent.notificationId() == CompilerData::szBuySellId) && (target == &anEvent.notifier()))
         return targetChanged;
      return skip;
   };
   virtual void performSetSource()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : BuySellField(text) to CompilerData(szBuySell))");
      ITRACE_DEVELOP(" setting source from target ");
      source->setText(target->szBuySell());
   };
   virtual void performSetTarget()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : BuySellField(text) to CompilerData(szBuySell))");
      ITRACE_DEVELOP(" setting target from source ");
      target->setSzBuySell(source->text());
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   IEntryField * source;
   CompilerData * target;


};   //MainScreenConn6


//*****************************************************************************
// Class definition for MainScreenConn7
//*****************************************************************************
class MainScreenConn7 : public IVBAttributeConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn7(IEntryField * aSource, CompilerData * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
      handleNotificationsFor(*target);
   };

   virtual  ~MainScreenConn7()
   {
      stopHandlingNotificationsFor(*source);
      stopHandlingNotificationsFor(*target);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      if ((anEvent.notificationId() == IEntryField::textId) && (source == &anEvent.notifier()))
         return sourceChanged;
      else
      if ((anEvent.notificationId() == CompilerData::szQtyId) && (target == &anEvent.notifier()))
         return targetChanged;
      return skip;
   };
   virtual void performSetSource()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : QtyField(text) to CompilerData(szQty))");
      ITRACE_DEVELOP(" setting source from target ");
      source->setText(target->szQty());
   };
   virtual void performSetTarget()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : QtyField(text) to CompilerData(szQty))");
      ITRACE_DEVELOP(" setting target from source ");
      target->setSzQty(source->text());
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   IEntryField * source;
   CompilerData * target;


};   //MainScreenConn7


//*****************************************************************************
// Class definition for MainScreenConn9
//*****************************************************************************
class MainScreenConn9 : public IVBAttributeConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn9(IEntryField * aSource, CompilerData * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
      handleNotificationsFor(*target);
   };

   virtual  ~MainScreenConn9()
   {
      stopHandlingNotificationsFor(*source);
      stopHandlingNotificationsFor(*target);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      if ((anEvent.notificationId() == IEntryField::textId) && (source == &anEvent.notifier()))
         return sourceChanged;
      else
      if ((anEvent.notificationId() == CompilerData::szInstrumentNameId) && (target == &anEvent.notifier()))
         return targetChanged;
      return skip;
   };
   virtual void performSetSource()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : InstrumentNameField(text) to CompilerData(szInstrumentName))");
      ITRACE_DEVELOP(" setting source from target ");
      source->setText(target->szInstrumentName());
   };
   virtual void performSetTarget()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : InstrumentNameField(text) to CompilerData(szInstrumentName))");
      ITRACE_DEVELOP(" setting target from source ");
      target->setSzInstrumentName(source->text());
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   IEntryField * source;
   CompilerData * target;


};   //MainScreenConn9


//*****************************************************************************
// Class definition for MainScreenConn11
//*****************************************************************************
class MainScreenConn11 : public IVBAttributeConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn11(IEntryField * aSource, CompilerData * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
      handleNotificationsFor(*target);
   };

   virtual  ~MainScreenConn11()
   {
      stopHandlingNotificationsFor(*source);
      stopHandlingNotificationsFor(*target);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      if ((anEvent.notificationId() == IEntryField::textId) && (source == &anEvent.notifier()))
         return sourceChanged;
      else
      if ((anEvent.notificationId() == CompilerData::szConsiderationId) && (target == &anEvent.notifier()))
         return targetChanged;
      return skip;
   };
   virtual void performSetSource()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : ConsiderationField(text) to CompilerData(szConsideration))");
      ITRACE_DEVELOP(" setting source from target ");
      source->setText(target->szConsideration());
   };
   virtual void performSetTarget()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : ConsiderationField(text) to CompilerData(szConsideration))");
      ITRACE_DEVELOP(" setting target from source ");
      target->setSzConsideration(source->text());
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   IEntryField * source;
   CompilerData * target;


};   //MainScreenConn11


//*****************************************************************************
// Class definition for MainScreenConn12
//*****************************************************************************
class MainScreenConn12 : public IVBAttributeConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn12(IEntryField * aSource, CompilerData * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
      handleNotificationsFor(*target);
   };

   virtual  ~MainScreenConn12()
   {
      stopHandlingNotificationsFor(*source);
      stopHandlingNotificationsFor(*target);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      if ((anEvent.notificationId() == IEntryField::textId) && (source == &anEvent.notifier()))
         return sourceChanged;
      else
      if ((anEvent.notificationId() == CompilerData::szStatusId) && (target == &anEvent.notifier()))
         return targetChanged;
      return skip;
   };
   virtual void performSetSource()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : StatusField(text) to CompilerData(szStatus))");
      ITRACE_DEVELOP(" setting source from target ");
      source->setText(target->szStatus());
   };
   virtual void performSetTarget()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : StatusField(text) to CompilerData(szStatus))");
      ITRACE_DEVELOP(" setting target from source ");
      target->setSzStatus(source->text());
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   IEntryField * source;
   CompilerData * target;


};   //MainScreenConn12


//*****************************************************************************
// Class definition for MainScreenConn13
//*****************************************************************************
class MainScreenConn13 : public IVBAttributeConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn13(IEntryField * aSource, CompilerData * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
      handleNotificationsFor(*target);
   };

   virtual  ~MainScreenConn13()
   {
      stopHandlingNotificationsFor(*source);
      stopHandlingNotificationsFor(*target);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      if ((anEvent.notificationId() == IEntryField::textId) && (source == &anEvent.notifier()))
         return sourceChanged;
      else
      if ((anEvent.notificationId() == CompilerData::szTradeTypeId) && (target == &anEvent.notifier()))
         return targetChanged;
      return skip;
   };
   virtual void performSetSource()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : TradeTypeField(text) to CompilerData(szTradeType))");
      ITRACE_DEVELOP(" setting source from target ");
      source->setText(target->szTradeType());
   };
   virtual void performSetTarget()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : TradeTypeField(text) to CompilerData(szTradeType))");
      ITRACE_DEVELOP(" setting target from source ");
      target->setSzTradeType(source->text());
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   IEntryField * source;
   CompilerData * target;


};   //MainScreenConn13


//*****************************************************************************
// Class definition for MainScreenConn14
//*****************************************************************************
class MainScreenConn14 : public IVBAttributeConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn14(IEntryField * aSource, CompilerData * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
      handleNotificationsFor(*target);
   };

   virtual  ~MainScreenConn14()
   {
      stopHandlingNotificationsFor(*source);
      stopHandlingNotificationsFor(*target);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      if ((anEvent.notificationId() == IEntryField::textId) && (source == &anEvent.notifier()))
         return sourceChanged;
      else
      if ((anEvent.notificationId() == CompilerData::szBookId) && (target == &anEvent.notifier()))
         return targetChanged;
      return skip;
   };
   virtual void performSetSource()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : BookField(text) to CompilerData(szBook))");
      ITRACE_DEVELOP(" setting source from target ");
      source->setText(target->szBook());
   };
   virtual void performSetTarget()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : BookField(text) to CompilerData(szBook))");
      ITRACE_DEVELOP(" setting target from source ");
      target->setSzBook(source->text());
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   IEntryField * source;
   CompilerData * target;


};   //MainScreenConn14


//*****************************************************************************
// Class definition for MainScreenConn15
//*****************************************************************************
class MainScreenConn15 : public IVBAttributeConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn15(IEntryField * aSource, CompilerData * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
      handleNotificationsFor(*target);
   };

   virtual  ~MainScreenConn15()
   {
      stopHandlingNotificationsFor(*source);
      stopHandlingNotificationsFor(*target);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      if ((anEvent.notificationId() == IEntryField::textId) && (source == &anEvent.notifier()))
         return sourceChanged;
      else
      if ((anEvent.notificationId() == CompilerData::szMarketId) && (target == &anEvent.notifier()))
         return targetChanged;
      return skip;
   };
   virtual void performSetSource()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : MarketField(text) to CompilerData(szMarket))");
      ITRACE_DEVELOP(" setting source from target ");
      source->setText(target->szMarket());
   };
   virtual void performSetTarget()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : MarketField(text) to CompilerData(szMarket))");
      ITRACE_DEVELOP(" setting target from source ");
      target->setSzMarket(source->text());
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   IEntryField * source;
   CompilerData * target;


};   //MainScreenConn15


//*****************************************************************************
// Class definition for MainScreenConn16
//*****************************************************************************
class MainScreenConn16 : public IVBAttributeConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn16(IEntryField * aSource, CompilerData * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
      handleNotificationsFor(*target);
   };

   virtual  ~MainScreenConn16()
   {
      stopHandlingNotificationsFor(*source);
      stopHandlingNotificationsFor(*target);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      if ((anEvent.notificationId() == IEntryField::textId) && (source == &anEvent.notifier()))
         return sourceChanged;
      else
      if ((anEvent.notificationId() == CompilerData::szSettlementTypeId) && (target == &anEvent.notifier()))
         return targetChanged;
      return skip;
   };
   virtual void performSetSource()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : SettlementTypeField(text) to CompilerData(szSettlementType))");
      ITRACE_DEVELOP(" setting source from target ");
      source->setText(target->szSettlementType());
   };
   virtual void performSetTarget()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : SettlementTypeField(text) to CompilerData(szSettlementType))");
      ITRACE_DEVELOP(" setting target from source ");
      target->setSzSettlementType(source->text());
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   IEntryField * source;
   CompilerData * target;


};   //MainScreenConn16


//*****************************************************************************
// Class definition for MainScreenConn17
//*****************************************************************************
class MainScreenConn17 : public IVBAttributeConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn17(IEntryField * aSource, CompilerData * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
      handleNotificationsFor(*target);
   };

   virtual  ~MainScreenConn17()
   {
      stopHandlingNotificationsFor(*source);
      stopHandlingNotificationsFor(*target);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      if ((anEvent.notificationId() == IEntryField::textId) && (source == &anEvent.notifier()))
         return sourceChanged;
      else
      if ((anEvent.notificationId() == CompilerData::szMessageTypeId) && (target == &anEvent.notifier()))
         return targetChanged;
      return skip;
   };
   virtual void performSetSource()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : MessageTypeField(text) to CompilerData(szMessageType))");
      ITRACE_DEVELOP(" setting source from target ");
      source->setText(target->szMessageType());
   };
   virtual void performSetTarget()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : MessageTypeField(text) to CompilerData(szMessageType))");
      ITRACE_DEVELOP(" setting target from source ");
      target->setSzMessageType(source->text());
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   IEntryField * source;
   CompilerData * target;


};   //MainScreenConn17


//*****************************************************************************
// Class definition for MainScreenConn18
//*****************************************************************************
class MainScreenConn18 : public IVBAttributeConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn18(IEntryField * aSource, CompilerData * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
      handleNotificationsFor(*target);
   };

   virtual  ~MainScreenConn18()
   {
      stopHandlingNotificationsFor(*source);
      stopHandlingNotificationsFor(*target);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      if ((anEvent.notificationId() == IEntryField::textId) && (source == &anEvent.notifier()))
         return sourceChanged;
      else
      if ((anEvent.notificationId() == CompilerData::szTradeDateId) && (target == &anEvent.notifier()))
         return targetChanged;
      return skip;
   };
   virtual void performSetSource()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : TradeDateField(text) to CompilerData(szTradeDate))");
      ITRACE_DEVELOP(" setting source from target ");
      source->setText(target->szTradeDate());
   };
   virtual void performSetTarget()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : TradeDateField(text) to CompilerData(szTradeDate))");
      ITRACE_DEVELOP(" setting target from source ");
      target->setSzTradeDate(source->text());
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   IEntryField * source;
   CompilerData * target;


};   //MainScreenConn18


//*****************************************************************************
// Class definition for MainScreenConn19
//*****************************************************************************
class MainScreenConn19 : public IVBAttributeConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn19(IEntryField * aSource, CompilerData * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
      handleNotificationsFor(*target);
   };

   virtual  ~MainScreenConn19()
   {
      stopHandlingNotificationsFor(*source);
      stopHandlingNotificationsFor(*target);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      if ((anEvent.notificationId() == IEntryField::textId) && (source == &anEvent.notifier()))
         return sourceChanged;
      else
      if ((anEvent.notificationId() == CompilerData::szTradeTimeId) && (target == &anEvent.notifier()))
         return targetChanged;
      return skip;
   };
   virtual void performSetSource()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : TradeTimeField(text) to CompilerData(szTradeTime))");
      ITRACE_DEVELOP(" setting source from target ");
      source->setText(target->szTradeTime());
   };
   virtual void performSetTarget()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : TradeTimeField(text) to CompilerData(szTradeTime))");
      ITRACE_DEVELOP(" setting target from source ");
      target->setSzTradeTime(source->text());
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   IEntryField * source;
   CompilerData * target;


};   //MainScreenConn19


//*****************************************************************************
// Class definition for MainScreenConn20
//*****************************************************************************
class MainScreenConn20 : public IVBAttributeConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn20(IEntryField * aSource, CompilerData * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
      handleNotificationsFor(*target);
   };

   virtual  ~MainScreenConn20()
   {
      stopHandlingNotificationsFor(*source);
      stopHandlingNotificationsFor(*target);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      if ((anEvent.notificationId() == IEntryField::textId) && (source == &anEvent.notifier()))
         return sourceChanged;
      else
      if ((anEvent.notificationId() == CompilerData::szSettlementDateId) && (target == &anEvent.notifier()))
         return targetChanged;
      return skip;
   };
   virtual void performSetSource()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : SettlementDateField(text) to CompilerData(szSettlementDate))");
      ITRACE_DEVELOP(" setting source from target ");
      source->setText(target->szSettlementDate());
   };
   virtual void performSetTarget()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : SettlementDateField(text) to CompilerData(szSettlementDate))");
      ITRACE_DEVELOP(" setting target from source ");
      target->setSzSettlementDate(source->text());
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   IEntryField * source;
   CompilerData * target;


};   //MainScreenConn20


//*****************************************************************************
// Class definition for MainScreenConn21
//*****************************************************************************
class MainScreenConn21 : public IVBAttributeConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn21(IEntryField * aSource, CompilerData * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
      handleNotificationsFor(*target);
   };

   virtual  ~MainScreenConn21()
   {
      stopHandlingNotificationsFor(*source);
      stopHandlingNotificationsFor(*target);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      if ((anEvent.notificationId() == IEntryField::textId) && (source == &anEvent.notifier()))
         return sourceChanged;
      else
      if ((anEvent.notificationId() == CompilerData::szDepotShortNameId) && (target == &anEvent.notifier()))
         return targetChanged;
      return skip;
   };
   virtual void performSetSource()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : DepotShortField(text) to CompilerData(szDepotShortName))");
      ITRACE_DEVELOP(" setting source from target ");
      source->setText(target->szDepotShortName());
   };
   virtual void performSetTarget()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : DepotShortField(text) to CompilerData(szDepotShortName))");
      ITRACE_DEVELOP(" setting target from source ");
      target->setSzDepotShortName(source->text());
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   IEntryField * source;
   CompilerData * target;


};   //MainScreenConn21


//*****************************************************************************
// Class definition for MainScreenConn22
//*****************************************************************************
class MainScreenConn22 : public IVBAttributeConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn22(IEntryField * aSource, CompilerData * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
      handleNotificationsFor(*target);
   };

   virtual  ~MainScreenConn22()
   {
      stopHandlingNotificationsFor(*source);
      stopHandlingNotificationsFor(*target);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      if ((anEvent.notificationId() == IEntryField::textId) && (source == &anEvent.notifier()))
         return sourceChanged;
      else
      if ((anEvent.notificationId() == CompilerData::szDepotLongNameId) && (target == &anEvent.notifier()))
         return targetChanged;
      return skip;
   };
   virtual void performSetSource()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : DepotLongField(text) to CompilerData(szDepotLongName))");
      ITRACE_DEVELOP(" setting source from target ");
      source->setText(target->szDepotLongName());
   };
   virtual void performSetTarget()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : DepotLongField(text) to CompilerData(szDepotLongName))");
      ITRACE_DEVELOP(" setting target from source ");
      target->setSzDepotLongName(source->text());
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   IEntryField * source;
   CompilerData * target;


};   //MainScreenConn22


//*****************************************************************************
// Class definition for MainScreenConn23
//*****************************************************************************
class MainScreenConn23 : public IVBAttributeConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn23(IEntryField * aSource, CompilerData * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
      handleNotificationsFor(*target);
   };

   virtual  ~MainScreenConn23()
   {
      stopHandlingNotificationsFor(*source);
      stopHandlingNotificationsFor(*target);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      if ((anEvent.notificationId() == IEntryField::textId) && (source == &anEvent.notifier()))
         return sourceChanged;
      else
      if ((anEvent.notificationId() == CompilerData::szNostrosShortNameId) && (target == &anEvent.notifier()))
         return targetChanged;
      return skip;
   };
   virtual void performSetSource()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : NostrosShortField(text) to CompilerData(szNostrosShortName))");
      ITRACE_DEVELOP(" setting source from target ");
      source->setText(target->szNostrosShortName());
   };
   virtual void performSetTarget()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : NostrosShortField(text) to CompilerData(szNostrosShortName))");
      ITRACE_DEVELOP(" setting target from source ");
      target->setSzNostrosShortName(source->text());
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   IEntryField * source;
   CompilerData * target;


};   //MainScreenConn23


//*****************************************************************************
// Class definition for MainScreenConn24
//*****************************************************************************
class MainScreenConn24 : public IVBAttributeConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn24(IEntryField * aSource, CompilerData * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
      handleNotificationsFor(*target);
   };

   virtual  ~MainScreenConn24()
   {
      stopHandlingNotificationsFor(*source);
      stopHandlingNotificationsFor(*target);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      if ((anEvent.notificationId() == IEntryField::textId) && (source == &anEvent.notifier()))
         return sourceChanged;
      else
      if ((anEvent.notificationId() == CompilerData::szNostrosLongNameId) && (target == &anEvent.notifier()))
         return targetChanged;
      return skip;
   };
   virtual void performSetSource()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : NostrosLongField(text) to CompilerData(szNostrosLongName))");
      ITRACE_DEVELOP(" setting source from target ");
      source->setText(target->szNostrosLongName());
   };
   virtual void performSetTarget()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : NostrosLongField(text) to CompilerData(szNostrosLongName))");
      ITRACE_DEVELOP(" setting target from source ");
      target->setSzNostrosLongName(source->text());
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   IEntryField * source;
   CompilerData * target;


};   //MainScreenConn24


//*****************************************************************************
// Class definition for MainScreenConn26
//*****************************************************************************
class MainScreenConn26 : public IVBAttributeConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn26(IEntryField * aSource, CompilerData * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
      handleNotificationsFor(*target);
   };

   virtual  ~MainScreenConn26()
   {
      stopHandlingNotificationsFor(*source);
      stopHandlingNotificationsFor(*target);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      if ((anEvent.notificationId() == IEntryField::textId) && (source == &anEvent.notifier()))
         return sourceChanged;
      else
      if ((anEvent.notificationId() == CompilerData::szMQQueueId) && (target == &anEvent.notifier()))
         return targetChanged;
      return skip;
   };
   virtual void performSetSource()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : EditBoxMQMessage(text) to CompilerData(szMQQueue))");
      ITRACE_DEVELOP(" setting source from target ");
      source->setText(target->szMQQueue());
   };
   virtual void performSetTarget()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : EditBoxMQMessage(text) to CompilerData(szMQQueue))");
      ITRACE_DEVELOP(" setting target from source ");
      target->setSzMQQueue(source->text());
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   IEntryField * source;
   CompilerData * target;


};   //MainScreenConn26


//*****************************************************************************
// Class definition for MainScreenConn35
//*****************************************************************************
class MainScreenConn35 : public IVBAttributeConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn35(IEntryField * aSource, CompilerData * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
      handleNotificationsFor(*target);
   };

   virtual  ~MainScreenConn35()
   {
      stopHandlingNotificationsFor(*source);
      stopHandlingNotificationsFor(*target);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      if ((anEvent.notificationId() == IEntryField::textId) && (source == &anEvent.notifier()))
         return sourceChanged;
      else
      if ((anEvent.notificationId() == CompilerData::szPriceId) && (target == &anEvent.notifier()))
         return targetChanged;
      return skip;
   };
   virtual void performSetSource()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : PriceField(text) to CompilerData(szPrice))");
      ITRACE_DEVELOP(" setting source from target ");
      source->setText(target->szPrice());
   };
   virtual void performSetTarget()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : PriceField(text) to CompilerData(szPrice))");
      ITRACE_DEVELOP(" setting target from source ");
      target->setSzPrice(source->text());
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   IEntryField * source;
   CompilerData * target;


};   //MainScreenConn35


//*****************************************************************************
// Class definition for MainScreenConn36
//*****************************************************************************
class MainScreenConn36 : public IVBAttributeConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn36(IEntryField * aSource, CompilerData * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
      handleNotificationsFor(*target);
   };

   virtual  ~MainScreenConn36()
   {
      stopHandlingNotificationsFor(*source);
      stopHandlingNotificationsFor(*target);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      if ((anEvent.notificationId() == IEntryField::textId) && (source == &anEvent.notifier()))
         return sourceChanged;
      else
      if ((anEvent.notificationId() == CompilerData::szCurrencyId) && (target == &anEvent.notifier()))
         return targetChanged;
      return skip;
   };
   virtual void performSetSource()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : CurrencyField(text) to CompilerData(szCurrency))");
      ITRACE_DEVELOP(" setting source from target ");
      source->setText(target->szCurrency());
   };
   virtual void performSetTarget()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : CurrencyField(text) to CompilerData(szCurrency))");
      ITRACE_DEVELOP(" setting target from source ");
      target->setSzCurrency(source->text());
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   IEntryField * source;
   CompilerData * target;


};   //MainScreenConn36


//*****************************************************************************
// Class definition for MainScreenConn40
//*****************************************************************************
class MainScreenConn40 : public IVBConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn40(ICanvas * aSource, IVBFlyText * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
   };

   virtual  ~MainScreenConn40()
   {
      stopHandlingNotificationsFor(*source);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      return true;
   };
   void perform(const INotificationEvent & anEvent)
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : Canvas(anyEvent) to VBFlyText(flyOverHelp))");
      target->enableFlyOverHelp();
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   ICanvas * source;
   IVBFlyText * target;


};   //MainScreenConn40


//*****************************************************************************
// Class definition for MainScreenConn31
//*****************************************************************************
class MainScreenConn31 : public IVBAttributeConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn31(IBitmapControl * aSource, CompilerData * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
      handleNotificationsFor(*target);
   };

   virtual  ~MainScreenConn31()
   {
      stopHandlingNotificationsFor(*source);
      stopHandlingNotificationsFor(*target);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      if ((anEvent.notificationId() == CompilerData::thisBitmapId) && (target == &anEvent.notifier()))
         return targetChanged;
      return skip;
   };
   virtual void performSetSource()
   {   };
   virtual void performSetTarget()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : BitmapControl1(this) to CompilerData(thisBitmap))");
      ITRACE_DEVELOP(" setting target from source ");
      target->setThisBitmap(source);
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   IBitmapControl * source;
   CompilerData * target;


};   //MainScreenConn31


//*****************************************************************************
// Class definition for MainScreenConn32
//*****************************************************************************
class MainScreenConn32 : public IVBAttributeConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn32(ICanvas * aSource, CompilerData * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
      handleNotificationsFor(*target);
   };

   virtual  ~MainScreenConn32()
   {
      stopHandlingNotificationsFor(*source);
      stopHandlingNotificationsFor(*target);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      if ((anEvent.notificationId() == CompilerData::thisMainWindowId) && (target == &anEvent.notifier()))
         return targetChanged;
      return skip;
   };
   virtual void performSetSource()
   {   };
   virtual void performSetTarget()
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : Canvas(this) to CompilerData(thisMainWindow))");
      ITRACE_DEVELOP(" setting target from source ");
      target->setThisMainWindow(source);
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   ICanvas * source;
   CompilerData * target;


};   //MainScreenConn32


//*****************************************************************************
// Class definition for MainScreenConn50
//*****************************************************************************
class MainScreenConn50 : public IVBConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn50(IPushButton * aSource, CompilerData * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
   };

   virtual  ~MainScreenConn50()
   {
      stopHandlingNotificationsFor(*source);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      return ((anEvent.notificationId() == IPushButton::buttonClickId));
   };
   void perform(const INotificationEvent & anEvent)
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : PushButton1(buttonClickEvent) to CompilerData(CreateMQmessage))");
      target->createMQmessage();
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   IPushButton * source;
   CompilerData * target;


};   //MainScreenConn50


//*****************************************************************************
// Class definition for MainScreenConn30
//*****************************************************************************
class MainScreenConn30 : public IVBConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn30(IPushButton * aSource, CompilerData * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
   };

   virtual  ~MainScreenConn30()
   {
      stopHandlingNotificationsFor(*source);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      return ((anEvent.notificationId() == IPushButton::buttonClickId));
   };
   void perform(const INotificationEvent & anEvent)
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : PushButton3(buttonClickEvent) to CompilerData(CreateMQmessage))");
      target->createMQmessage();
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   IPushButton * source;
   CompilerData * target;


};   //MainScreenConn30


//*****************************************************************************
// Class definition for MainScreenConn41
//*****************************************************************************
class MainScreenConn41 : public IVBConnection {
public:
   //---------------------------------------------------------------------------
   // Constructors / destructors
   //---------------------------------------------------------------------------
   MainScreenConn41(IPushButton * aSource, IPushButton * aTarget) : 
      source(aSource), target(aTarget) 
   {
      handleNotificationsFor(*source);
   };

   virtual  ~MainScreenConn41()
   {
      stopHandlingNotificationsFor(*source);
   };

   //---------------------------------------------------------------------------
   // public member functions
   //---------------------------------------------------------------------------
   virtual int checkEvent(const INotificationEvent & anEvent) const
   {
      return ((anEvent.notificationId() == IPushButton::buttonClickId));
   };
   void perform(const INotificationEvent & anEvent)
   {
      IFUNCTRACE_DEVELOP();
      ITRACE_DEVELOP(" firing connection : PushButton1(buttonClickEvent) to PushButton1(disable))");
      target->disable();
   };

protected:
private:
   //---------------------------------------------------------------------------
   // private member data
   //---------------------------------------------------------------------------
   IPushButton * source;
   IPushButton * target;


};   //MainScreenConn41


const INotificationId _Export MainScreen::readyId = "MainScreen::readyId";

//------------------------------------------------------------------------------
// MainScreen :: defaultFramingSpec
//------------------------------------------------------------------------------
const IRectangle _Export MainScreen::defaultFramingSpec()
{
   return(IRectangle(VBPOINT(0, IWindow::desktopWindow()->size().height() - -4 - 651, 0, -4), ISize(573, 651)));
}

//------------------------------------------------------------------------------
// MainScreen :: defaultTitle
//------------------------------------------------------------------------------
IString _Export MainScreen::defaultTitle()
{
   return("Straight Through Processing - [Trade Screen] - Edit Mode");
}

//------------------------------------------------------------------------------
// MainScreen :: MainScreen
//------------------------------------------------------------------------------
_Export MainScreen::MainScreen(
      unsigned long id, 
      IWindow* parent, 
      IWindow* owner, 
      const IRectangle& rect, 
      const IFrameWindow::Style& style, 
      const char* title)
   : IFrameWindow(id, parent, owner, rect, style, title)
{
   iMainScreenConnectionList = new IVBConnectionList;

   iCanvas = new ICanvas(
      IC_FRAME_CLIENT_ID, 
      this, 
      this, 
      IRectangle());
   iStaticText12 = new IStaticText(
      id+WNDOFFSET_MainScreen_StaticText12, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(34, 572, 34, 38), ISize(73, 14)));
   iCounterPartyField = new IEntryField(
      id+WNDOFFSET_MainScreen_CounterPartyField, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(35, 545, 35, 58), ISize(80, 21)));
   iStaticText13 = new IStaticText(
      id+WNDOFFSET_MainScreen_StaticText13, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(151, 572, 151, 38), ISize(63, 14)));
   iInternalRef = new IEntryField(
      id+WNDOFFSET_MainScreen_InternalRef, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(150, 545, 150, 57), ISize(81, 22)));
   iStaticText14 = new IStaticText(
      id+WNDOFFSET_MainScreen_StaticText14, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(261, 572, 261, 38), ISize(65, 14)));
   iExternalRefField = new IEntryField(
      id+WNDOFFSET_MainScreen_ExternalRefField, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(259, 545, 259, 58), ISize(97, 21)));
   iStaticText15 = new IStaticText(
      id+WNDOFFSET_MainScreen_StaticText15, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(61, 514, 61, 96), ISize(62, 14)));
   iISINField = new IEntryField(
      id+WNDOFFSET_MainScreen_ISINField, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(40, 482, 40, 119), ISize(42, 23)));
   iInstrumentNoField = new IEntryField(
      id+WNDOFFSET_MainScreen_InstrumentNoField, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(103, 483, 103, 119), ISize(75, 22)));
   iInstrumentNameField = new IEntryField(
      id+WNDOFFSET_MainScreen_InstrumentNameField, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(204, 483, 204, 120), ISize(263, 21)));
   iStaticText16 = new IStaticText(
      id+WNDOFFSET_MainScreen_StaticText16, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(209, 514, 209, 97), ISize(96, 13)));
   iStaticText17 = new IStaticText(
      id+WNDOFFSET_MainScreen_StaticText17, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(41, 448, 41, 162), ISize(43, 14)));
   iBuySellField = new IEntryField(
      id+WNDOFFSET_MainScreen_BuySellField, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(34, 421, 34, 183), ISize(65, 20)));
   iStaticText18 = new IStaticText(
      id+WNDOFFSET_MainScreen_StaticText18, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(115, 448, 115, 162), ISize(18, 14)));
   iQtyField = new IEntryField(
      id+WNDOFFSET_MainScreen_QtyField, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(111, 421, 111, 182), ISize(28, 21)));
   iStaticText19 = new IStaticText(
      id+WNDOFFSET_MainScreen_StaticText19, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(235, 448, 235, 162), ISize(51, 14)));
   iCurrencyField = new IEntryField(
      id+WNDOFFSET_MainScreen_CurrencyField, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(226, 421, 226, 181), ISize(93, 22)));
   iStaticText20 = new IStaticText(
      id+WNDOFFSET_MainScreen_StaticText20, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(330, 448, 330, 162), ISize(109, 14)));
   iConsiderationField = new IEntryField(
      id+WNDOFFSET_MainScreen_ConsiderationField, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(334, 421, 334, 181), ISize(116, 22)));
   iStaticText21 = new IStaticText(
      id+WNDOFFSET_MainScreen_StaticText21, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(467, 448, 467, 162), ISize(35, 14)));
   iStatusField = new IEntryField(
      id+WNDOFFSET_MainScreen_StatusField, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(464, 420, 464, 181), ISize(66, 23)));
   iStaticText1 = new IStaticText(
      id+WNDOFFSET_MainScreen_StaticText1, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(40, 337, 40, 273), ISize(62, 14)));
   iTradeTypeField = new IEntryField(
      id+WNDOFFSET_MainScreen_TradeTypeField, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(39, 308, 39, 295), ISize(81, 21)));
   iStaticText2 = new IStaticText(
      id+WNDOFFSET_MainScreen_StaticText2, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(145, 337, 145, 273), ISize(28, 14)));
   iBookField = new IEntryField(
      id+WNDOFFSET_MainScreen_BookField, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(141, 309, 141, 293), ISize(64, 22)));
   iStaticText3 = new IStaticText(
      id+WNDOFFSET_MainScreen_StaticText3, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(232, 338, 232, 272), ISize(39, 14)));
   iMarketField = new IEntryField(
      id+WNDOFFSET_MainScreen_MarketField, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(229, 311, 229, 292), ISize(73, 21)));
   iStaticText4 = new IStaticText(
      id+WNDOFFSET_MainScreen_StaticText4, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(40, 278, 40, 332), ISize(91, 14)));
   iSettlementTypeField = new IEntryField(
      id+WNDOFFSET_MainScreen_SettlementTypeField, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(39, 251, 39, 350), ISize(268, 23)));
   iStaticText5 = new IStaticText(
      id+WNDOFFSET_MainScreen_StaticText5, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(339, 280, 339, 330), ISize(81, 14)));
   iMessageTypeField = new IEntryField(
      id+WNDOFFSET_MainScreen_MessageTypeField, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(336, 252, 336, 349), ISize(114, 23)));
   iStaticText6 = new IStaticText(
      id+WNDOFFSET_MainScreen_StaticText6, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(43, 213, 43, 397), ISize(59, 14)));
   iTradeDateField = new IEntryField(
      id+WNDOFFSET_MainScreen_TradeDateField, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(42, 185, 42, 418), ISize(79, 21)));
   iStaticText7 = new IStaticText(
      id+WNDOFFSET_MainScreen_StaticText7, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(149, 213, 149, 397), ISize(63, 14)));
   iTradeTimeField = new IEntryField(
      id+WNDOFFSET_MainScreen_TradeTimeField, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(148, 186, 148, 416), ISize(79, 22)));
   iStaticText8 = new IStaticText(
      id+WNDOFFSET_MainScreen_StaticText8, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(255, 213, 255, 397), ISize(88, 14)));
   iSettlementDateField = new IEntryField(
      id+WNDOFFSET_MainScreen_SettlementDateField, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(255, 188, 255, 415), ISize(97, 21)));
   iPushButton1 = new IPushButton(
      id+WNDOFFSET_MainScreen_PushButton1, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(128, 18, 128, 586), ISize(88, 20)));
   iStaticText11 = new IStaticText(
      id+WNDOFFSET_MainScreen_StaticText11, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(46, 149, 46, 461), ISize(32, 14)));
   iDepotShortField = new IEntryField(
      id+WNDOFFSET_MainScreen_DepotShortField, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(43, 125, 43, 478), ISize(95, 21)));
   iDepotLongField = new IEntryField(
      id+WNDOFFSET_MainScreen_DepotLongField, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(147, 125, 147, 478), ISize(273, 21)));
   iStaticText9 = new IStaticText(
      id+WNDOFFSET_MainScreen_StaticText9, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(44, 98, 44, 512), ISize(44, 14)));
   iNostrosShortField = new IEntryField(
      id+WNDOFFSET_MainScreen_NostrosShortField, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(43, 72, 43, 530), ISize(89, 22)));
   iNostrosLongField = new IEntryField(
      id+WNDOFFSET_MainScreen_NostrosLongField, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(148, 72, 148, 530), ISize(272, 22)));
   iPushButton2 = new IPushButton(
      id+WNDOFFSET_MainScreen_PushButton2, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(238, 19, 238, 584), ISize(51, 21)));
   iStaticText10 = new IStaticText(
      id+WNDOFFSET_MainScreen_StaticText10, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(153, 448, 153, 161), ISize(33, 15)));
   iPriceField = new IEntryField(
      id+WNDOFFSET_MainScreen_PriceField, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(152, 421, 152, 183), ISize(60, 20)));
   iEditBoxMQMessage = new IEntryField(
      id+WNDOFFSET_MainScreen_EditBoxMQMessage, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(446, 17, 446, 584), ISize(101, 23)), 
      IEntryField::defaultStyle() & ~IWindow::visible);
   iBitmapControl1 = new IBitmapControl(
      id+WNDOFFSET_MainScreen_BitmapControl1, 
      iCanvas, 
      iCanvas, 
      IBitmapHandle (), 
      IRectangle(VBPOINT(2, 592, 2, 0), ISize(32, 32)), 
      IBitmapControl::defaultStyle() | IBitmapControl::sizeToBitmap | IWindow::clipSiblings | IWindow::synchPaint);
   iPushButton3 = new IPushButton(
      id+WNDOFFSET_MainScreen_PushButton3, 
      iCanvas, 
      iCanvas, 
      IRectangle(VBPOINT(17, 27, 17, 580), ISize(23, 17)), 
      IPushButton::defaultStyle() & ~IWindow::visible);
   iCompilerData = new CompilerData();
   iVBFlyText = new IVBFlyText(this);

   iStaticText12->setFont(IFont("Arial", 8).setBold(true).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText12->setText("CounterParty");
   iCounterPartyField->setText("HSAMLN");
   iCounterPartyField->setFont(IFont("Arial", 8).setBold(false).setItalic(false).setUnderscore(false).setStrikeout(false));
   iCounterPartyField->setForegroundColor(IColor(IColor::black));
   iStaticText13->setFont(IFont("Arial", 8).setBold(true).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText13->setText("Internal Ref");
   iInternalRef->setText("100123");
   iInternalRef->setFont(IFont("Arial", 8).setBold(false).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText14->setFont(IFont("Arial", 8).setBold(true).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText14->setText("External Ref");
   iExternalRefField->setText("200234");
   iExternalRefField->setFont(IFont("Arial", 8).setBold(false).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText15->setFont(IFont("Arial", 8).setBold(true).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText15->setText("Instrument");
   iISINField->setText("ISIN");
   iISINField->setFont(IFont("Arial", 8).setBold(false).setItalic(false).setUnderscore(false).setStrikeout(false));
   iInstrumentNoField->setText("GB007908733");
   iInstrumentNoField->setFont(IFont("Arial", 8).setBold(false).setItalic(false).setUnderscore(false).setStrikeout(false));
   iInstrumentNameField->setLimit(70);
   iInstrumentNameField->setText("SCOTTISH & SOUTHERLY HILL SAMUEL ASSET MG");
   iInstrumentNameField->setFont(IFont("Arial", 8).setBold(false).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText16->setFont(IFont("Arial", 8).setBold(true).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText16->setText("Instrument Name");
   iStaticText17->setFont(IFont("Arial", 8).setBold(true).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText17->setText("Buy/Sell");
   iBuySellField->setText("SELL");
   iBuySellField->setFont(IFont("Arial", 8).setBold(false).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText18->setFont(IFont("Arial", 8).setBold(true).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText18->setText("Qty");
   iQtyField->setText("22");
   iQtyField->setFont(IFont("Arial", 8).setBold(false).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText19->setFont(IFont("Arial", 8).setBold(true).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText19->setText("Currency");
   iCurrencyField->setText("GBP");
   iCurrencyField->setFont(IFont("Arial", 8).setBold(false).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText20->setFont(IFont("Arial", 8).setBold(true).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText20->setText("Consideration (NET)");
   iConsiderationField->setText("374000");
   iConsiderationField->setFont(IFont("Arial", 8).setBold(false).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText21->setFont(IFont("Arial", 8).setBold(true).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText21->setText("Status");
   iStatusField->setText("AMENDING");
   iStatusField->setFont(IFont("Arial", 8).setBold(false).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText1->setFont(IFont("Arial", 8).setBold(true).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText1->setText("Trade Type");
   iTradeTypeField->setText("PRINCIPAL");
   iTradeTypeField->setFont(IFont("Arial", 8).setBold(false).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText2->setFont(IFont("Arial", 8).setBold(true).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText2->setText("Book");
   iBookField->setText("LNEBST2");
   iBookField->setFont(IFont("Arial", 8).setBold(false).setItalic(false).setUnderscore(false).setStrikeout(false));
   iBookField->setForegroundColor(IColor(IColor::black));
   iStaticText3->setFont(IFont("Arial", 8).setBold(true).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText3->setText("Market");
   iMarketField->setText("GERMANY");
   iMarketField->setFont(IFont("Arial", 8).setBold(false).setItalic(false).setUnderscore(false).setStrikeout(false));
   iMarketField->setForegroundColor(IColor(IColor::black));
   iStaticText4->setFont(IFont("Arial", 8).setBold(true).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText4->setText("Settlement Type");
   iSettlementTypeField->setText("CASH ON DELIVERY");
   iSettlementTypeField->setFont(IFont("Arial", 8).setBold(false).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText5->setFont(IFont("Arial", 8).setBold(true).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText5->setText("Message Type");
   iMessageTypeField->setText("SWIFTMT531");
   iMessageTypeField->setFont(IFont("Arial", 8).setBold(false).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText6->setFont(IFont("Arial", 8).setBold(true).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText6->setText("Trade Date");
   iTradeDateField->setText("05/08/99");
   iTradeDateField->setFont(IFont("Arial", 8).setBold(false).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText7->setFont(IFont("Arial", 8).setBold(true).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText7->setText("Trade Time");
   iTradeTimeField->setText("12:32");
   iTradeTimeField->setFont(IFont("Arial", 8).setBold(false).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText8->setFont(IFont("Arial", 8).setBold(true).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText8->setText("Settlement Date");
   iSettlementDateField->setText("12/08/99");
   iSettlementDateField->setFont(IFont("Arial", 8).setBold(false).setItalic(false).setUnderscore(false).setStrikeout(false));
   iSettlementDateField->setForegroundColor(IColor(IColor::black));
   iPushButton1->setFont(IFont("Arial", 8).setBold(true).setItalic(false).setUnderscore(false).setStrikeout(false));
   iPushButton1->setText("Start Workflow");
   iPushButton1->setForegroundColor(IColor(IColor::darkBlue));
   iStaticText11->setFont(IFont("Arial", 8).setBold(true).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText11->setText("Depot");
   iDepotShortField->setText("OURS OCITILON");
   iDepotShortField->setFont(IFont("Arial", 8).setBold(false).setItalic(false).setUnderscore(false).setStrikeout(false));
   iDepotLongField->setLimit(60);
   iDepotLongField->setText("OUR CITIBANK NA - LO CRSP CITIBANK NA LONDON");
   iDepotLongField->setFont(IFont("Arial", 8).setBold(false).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText9->setFont(IFont("Arial", 8).setBold(true).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText9->setText("Nostros");
   iNostrosShortField->setText("OURS OCITILON");
   iNostrosShortField->setFont(IFont("Arial", 8).setBold(false).setItalic(false).setUnderscore(false).setStrikeout(false));
   iNostrosLongField->setLimit(60);
   iNostrosLongField->setText("OUR CITIBANK NA - LO CRSP CITIBANK NA LONDON");
   iNostrosLongField->setFont(IFont("Arial", 8).setBold(false).setItalic(false).setUnderscore(false).setStrikeout(false));
   iPushButton2->setFont(IFont("Arial", 8).setBold(true).setItalic(false).setUnderscore(false).setStrikeout(false));
   iPushButton2->setText("E&xit");
   iStaticText10->setFont(IFont("Arial", 8).setBold(true).setItalic(false).setUnderscore(false).setStrikeout(false));
   iStaticText10->setText("Price");
   iPriceField->setText("17000");
   iPriceField->setFont(IFont("Arial", 8).setBold(false).setItalic(false).setUnderscore(false).setStrikeout(false));
   iEditBoxMQMessage->setText("STP_QUEUE");
   iPushButton3->setText("PushButton3");
   this->setClient(iCanvas);
   this->setBackgroundColor(IColor(IColor::paleGray));
   this->setFocus();
   iCompilerData->setSzQty("22");
   IFlyOverHelpHandler * iVBFlyTextHandler = iVBFlyText->flyOverHelpHandler();
   iVBFlyTextHandler->setHelpText(iStaticText12->handle(), "A client that is buying/selling shares.", "");
   iVBFlyTextHandler->setHelpText(iStaticText13->handle(), "The internal reference number of this trade.", "");
   iVBFlyTextHandler->setHelpText(iStaticText14->handle(), "The external reference number of this trade.", "");
   iVBFlyTextHandler->setHelpText(iStaticText15->handle(), "Securities Identification Number unique to each security. ", "");
   iVBFlyTextHandler->setHelpText(iISINField->handle(), "Securities Identification Number unique to each security. ", "");
   iVBFlyTextHandler->setHelpText(iInstrumentNoField->handle(), "Securities Identification Number unique to each security. ", "");
   iVBFlyTextHandler->setHelpText(iStaticText16->handle(), "The name of the company issuing the share", "");
   iVBFlyTextHandler->setHelpText(iStaticText17->handle(), "Buying or selling shares.", "");
   iVBFlyTextHandler->setHelpText(iStaticText18->handle(), "Number of shares being traded.", "");
   iVBFlyTextHandler->setHelpText(iStaticText19->handle(), "The currency the shares are valued in.", "");
   iVBFlyTextHandler->setHelpText(iStaticText20->handle(), "Cost of shares derived from No. of shares x share price.", "");
   iVBFlyTextHandler->setHelpText(iStaticText21->handle(), "The current status of the trade.", "");
   iVBFlyTextHandler->setHelpText(iStaticText1->handle(), "A firm sells/buys from/to its own portfolio of holdings.", "");
   iVBFlyTextHandler->setHelpText(iStaticText2->handle(), "Firm's accounting book symbolising the share holding.", "");
   iVBFlyTextHandler->setHelpText(iStaticText3->handle(), "The nation on whose exchange the security is traded.", "");
   iVBFlyTextHandler->setHelpText(iStaticText4->handle(), "Method of payment, ie. Deliver vs Payment.", "");
   iVBFlyTextHandler->setHelpText(iStaticText5->handle(), "Confirmation of trade received in medium specified.", "");
   iVBFlyTextHandler->setHelpText(iStaticText6->handle(), "Date that the deal is inputted by the trader.", "");
   iVBFlyTextHandler->setHelpText(iStaticText7->handle(), "The time of trade inputted.", "");
   iVBFlyTextHandler->setHelpText(iStaticText8->handle(), "Date that the deal is due to settle.", "");
   iVBFlyTextHandler->setHelpText(iStaticText11->handle(), "Where company shares are held, ie. Custodian bank.", "");
   iVBFlyTextHandler->setHelpText(iStaticText9->handle(), "Bank holding currency account.", "");
   iVBFlyTextHandler->setHelpText(iStaticText10->handle(), "Market price per share.", "");
}     //end constructor

//------------------------------------------------------------------------------
// MainScreen :: ~MainScreen
//------------------------------------------------------------------------------
_Export MainScreen::~MainScreen()
{
   delete iMainScreenConnectionList;

   delete iVBFlyText;
   delete iCompilerData;
   delete iPushButton3;
   delete iBitmapControl1;
   delete iEditBoxMQMessage;
   delete iPriceField;
   delete iStaticText10;
   delete iPushButton2;
   delete iNostrosLongField;
   delete iNostrosShortField;
   delete iStaticText9;
   delete iDepotLongField;
   delete iDepotShortField;
   delete iStaticText11;
   delete iPushButton1;
   delete iSettlementDateField;
   delete iStaticText8;
   delete iTradeTimeField;
   delete iStaticText7;
   delete iTradeDateField;
   delete iStaticText6;
   delete iMessageTypeField;
   delete iStaticText5;
   delete iSettlementTypeField;
   delete iStaticText4;
   delete iMarketField;
   delete iStaticText3;
   delete iBookField;
   delete iStaticText2;
   delete iTradeTypeField;
   delete iStaticText1;
   delete iStatusField;
   delete iStaticText21;
   delete iConsiderationField;
   delete iStaticText20;
   delete iCurrencyField;
   delete iStaticText19;
   delete iQtyField;
   delete iStaticText18;
   delete iBuySellField;
   delete iStaticText17;
   delete iStaticText16;
   delete iInstrumentNameField;
   delete iInstrumentNoField;
   delete iISINField;
   delete iStaticText15;
   delete iExternalRefField;
   delete iStaticText14;
   delete iInternalRef;
   delete iStaticText13;
   delete iCounterPartyField;
   delete iStaticText12;
   delete iCanvas;
}

//------------------------------------------------------------------------------
// MainScreen :: initializePart
//------------------------------------------------------------------------------
MainScreen & _Export MainScreen::initializePart()
{
   makeConnections();
   notifyObservers(INotificationEvent(readyId, *this));
   return *this;
}

//------------------------------------------------------------------------------
// MainScreen :: makeConnections
//------------------------------------------------------------------------------
void _Export MainScreen::makeConnections()
{
   this->enableNotification();
   iCanvas->enableNotification();
   iStaticText12->enableNotification();
   iCounterPartyField->enableNotification();
   iStaticText13->enableNotification();
   iInternalRef->enableNotification();
   iStaticText14->enableNotification();
   iExternalRefField->enableNotification();
   iStaticText15->enableNotification();
   iISINField->enableNotification();
   iInstrumentNoField->enableNotification();
   iInstrumentNameField->enableNotification();
   iStaticText16->enableNotification();
   iStaticText17->enableNotification();
   iBuySellField->enableNotification();
   iStaticText18->enableNotification();
   iQtyField->enableNotification();
   iStaticText19->enableNotification();
   iCurrencyField->enableNotification();
   iStaticText20->enableNotification();
   iConsiderationField->enableNotification();
   iStaticText21->enableNotification();
   iStatusField->enableNotification();
   iStaticText1->enableNotification();
   iTradeTypeField->enableNotification();
   iStaticText2->enableNotification();
   iBookField->enableNotification();
   iStaticText3->enableNotification();
   iMarketField->enableNotification();
   iStaticText4->enableNotification();
   iSettlementTypeField->enableNotification();
   iStaticText5->enableNotification();
   iMessageTypeField->enableNotification();
   iStaticText6->enableNotification();
   iTradeDateField->enableNotification();
   iStaticText7->enableNotification();
   iTradeTimeField->enableNotification();
   iStaticText8->enableNotification();
   iSettlementDateField->enableNotification();
   iPushButton1->enableNotification();
   iStaticText11->enableNotification();
   iDepotShortField->enableNotification();
   iDepotLongField->enableNotification();
   iStaticText9->enableNotification();
   iNostrosShortField->enableNotification();
   iNostrosLongField->enableNotification();
   iPushButton2->enableNotification();
   iStaticText10->enableNotification();
   iPriceField->enableNotification();
   iEditBoxMQMessage->enableNotification();
   iBitmapControl1->enableNotification();
   iPushButton3->enableNotification();
   iCompilerData->enableNotification();
   iVBFlyText->enableNotification();

   unsigned long id = this->id();
   MainScreenConn0 *conn0 = new MainScreenConn0(iPushButton2, this);
   iMainScreenConnectionList->add(conn0);
   MainScreenConn1 *conn1 = new MainScreenConn1(iCounterPartyField, iCompilerData);
   iMainScreenConnectionList->add(conn1);
   MainScreenConn2 *conn2 = new MainScreenConn2(iInternalRef, iCompilerData);
   iMainScreenConnectionList->add(conn2);
   MainScreenConn3 *conn3 = new MainScreenConn3(iExternalRefField, iCompilerData);
   iMainScreenConnectionList->add(conn3);
   MainScreenConn4 *conn4 = new MainScreenConn4(iISINField, iCompilerData);
   iMainScreenConnectionList->add(conn4);
   MainScreenConn5 *conn5 = new MainScreenConn5(iInstrumentNoField, iCompilerData);
   iMainScreenConnectionList->add(conn5);
   MainScreenConn6 *conn6 = new MainScreenConn6(iBuySellField, iCompilerData);
   iMainScreenConnectionList->add(conn6);
   MainScreenConn7 *conn7 = new MainScreenConn7(iQtyField, iCompilerData);
   iMainScreenConnectionList->add(conn7);
   MainScreenConn9 *conn9 = new MainScreenConn9(iInstrumentNameField, iCompilerData);
   iMainScreenConnectionList->add(conn9);
   MainScreenConn11 *conn11 = new MainScreenConn11(iConsiderationField, iCompilerData);
   iMainScreenConnectionList->add(conn11);
   MainScreenConn12 *conn12 = new MainScreenConn12(iStatusField, iCompilerData);
   iMainScreenConnectionList->add(conn12);
   MainScreenConn13 *conn13 = new MainScreenConn13(iTradeTypeField, iCompilerData);
   iMainScreenConnectionList->add(conn13);
   MainScreenConn14 *conn14 = new MainScreenConn14(iBookField, iCompilerData);
   iMainScreenConnectionList->add(conn14);
   MainScreenConn15 *conn15 = new MainScreenConn15(iMarketField, iCompilerData);
   iMainScreenConnectionList->add(conn15);
   MainScreenConn16 *conn16 = new MainScreenConn16(iSettlementTypeField, iCompilerData);
   iMainScreenConnectionList->add(conn16);
   MainScreenConn17 *conn17 = new MainScreenConn17(iMessageTypeField, iCompilerData);
   iMainScreenConnectionList->add(conn17);
   MainScreenConn18 *conn18 = new MainScreenConn18(iTradeDateField, iCompilerData);
   iMainScreenConnectionList->add(conn18);
   MainScreenConn19 *conn19 = new MainScreenConn19(iTradeTimeField, iCompilerData);
   iMainScreenConnectionList->add(conn19);
   MainScreenConn20 *conn20 = new MainScreenConn20(iSettlementDateField, iCompilerData);
   iMainScreenConnectionList->add(conn20);
   MainScreenConn21 *conn21 = new MainScreenConn21(iDepotShortField, iCompilerData);
   iMainScreenConnectionList->add(conn21);
   MainScreenConn22 *conn22 = new MainScreenConn22(iDepotLongField, iCompilerData);
   iMainScreenConnectionList->add(conn22);
   MainScreenConn23 *conn23 = new MainScreenConn23(iNostrosShortField, iCompilerData);
   iMainScreenConnectionList->add(conn23);
   MainScreenConn24 *conn24 = new MainScreenConn24(iNostrosLongField, iCompilerData);
   iMainScreenConnectionList->add(conn24);
   MainScreenConn26 *conn26 = new MainScreenConn26(iEditBoxMQMessage, iCompilerData);
   iMainScreenConnectionList->add(conn26);
   MainScreenConn35 *conn35 = new MainScreenConn35(iPriceField, iCompilerData);
   iMainScreenConnectionList->add(conn35);
   MainScreenConn36 *conn36 = new MainScreenConn36(iCurrencyField, iCompilerData);
   iMainScreenConnectionList->add(conn36);
   MainScreenConn40 *conn40 = new MainScreenConn40(iCanvas, iVBFlyText);
   iMainScreenConnectionList->add(conn40);
   MainScreenConn31 *conn31 = new MainScreenConn31(iBitmapControl1, iCompilerData);
   iMainScreenConnectionList->add(conn31);
   MainScreenConn32 *conn32 = new MainScreenConn32(iCanvas, iCompilerData);
   iMainScreenConnectionList->add(conn32);
   MainScreenConn50 *conn50 = new MainScreenConn50(iPushButton1, iCompilerData);
   iMainScreenConnectionList->add(conn50);
   MainScreenConn30 *conn30 = new MainScreenConn30(iPushButton3, iCompilerData);
   iMainScreenConnectionList->add(conn30);
   MainScreenConn41 *conn41 = new MainScreenConn41(iPushButton1, iPushButton1);
   iMainScreenConnectionList->add(conn41);


   iMainScreenConnectionList->initialize();
}


