/********************************************************************/
/*                                                                  */
/* Program name: BackendFAX                                         */
/*                                                                  */
/* Description: This is a Backend application program.              */

/* Written  :   16/09/1999 Humayon Salim                            */
/*                                                                  */
/********************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <iostream.h>
#include <conio.h>

//MQ header
#include <imqi.hpp>

//********************************************************************
// G L O B A L   D A T A   A N D   F U N C T I O N S
//********************************************************************

FILE*            outFileStream;
char*            outFile = "BackendFAX.out";

void ParseMessageData(char*);
void DisplayFAX(char*,
                char*,
                char*,
                char*,
                char*,
                char*,
                char*,
                char*,
                char*,
                char*,
                char* );

//*******************************************************************
//
// RETRIEVE MESSAGE
// This function retrieves the message from QUEUE1 and displays it
// on the screen.
//*******************************************************************

void retrieveMessage()
{
  ImqQueueManager         QMgr;             // Queue manager
  ImqQueue                queue;            // Queue
  ImqMessage              msg;              // MQ message
  ImqGetMessageOptions    getMsgOptions;    // Get message options

  char                    msgBuffer[350];  // buffer for message data

  int                     getContinue;       // flag

  char                    a;

  fprintf( outFileStream, "\n================ Start of MQSeries Log ===================\n");

  // Connect to the local queue manager
  if ( ! QMgr.connect( ) )
  {
     /* stop if it failed     */
     fprintf( outFileStream, "ImqQueueManager::connect failed with reason code %ld\n",
             QMgr.reasonCode( ) );
     exit(-1);
  }

  // Now we open the input queue
  queue.setName("FAX_QUEUE") ;
  queue.setConnectionReference(QMgr);
  queue.setOpenOptions( MQOO_INPUT_SHARED ) ;
  if ( ! queue.open() )
  {
     fprintf( outFileStream, "\nImqQueue::open ended with reason code %ld\n", queue.reasonCode());
     exit(-1);
  }

  //define where the message data should be put
  msg.useEmptyBuffer(msgBuffer, sizeof(msgBuffer) - 1);

  //set up the get message options
  getMsgOptions.setOptions( MQGMO_WAIT );
  getMsgOptions.setWaitInterval( MQWI_UNLIMITED );

  getContinue = TRUE;



     printf("===========================================================================\n");
     printf("\n New Message..                                                           \n");
     printf("===========================================================================\n");
     fprintf(outFileStream, "\n New message retrieved from queue: FAX_BACKEND_QUEUE .\n");

     // reset the message and correl ids.
     msg.setMessageId( (MQBYTE*)MQMI_NONE );
     msg.setCorrelationId( (MQBYTE*)MQMI_NONE );

     if ( ! queue.get( msg, getMsgOptions ))
     {
        //the get didn't work for some reason
        fprintf(outFileStream, "\nImqQueue::get ended with reason code %ld\n",
                                                        queue.reasonCode());
        getContinue = FALSE;
     }
     else
     {
        //the get of the reply msg worked
        printf("========================================================================\n");
        printf("            Message Content: %s\n", msgBuffer);
        printf("========================================================================\n");

        fprintf( outFileStream, "\nThe message is : %s\n", msgBuffer);


     }
     fflush(outFileStream);


  if ( ! queue.close( ) )
  {
     fprintf( outFileStream, "\nImqQueue::close ended with reason code %ld\n",
                                                       queue.reasonCode());
     exit(-1);
  }

  ParseMessageData(msgBuffer);
}
// ============================================================================================
void ParseMessageData(char* msgBuffer)
{

   char  buf2[2]=";";
   char*  Field1;
   int counter;
   char* NextField;

   char NewField[20][20];


   char                    ExternalRef[20];
   char                    PrepDateTime [22];
   char                    LinkedTransaction[20];
   char                    TransactionNo[20];

   char                    TradeDateTime[20];
   char                    DealPrice[20];
   char                    BuySell[20];
   char                    SettlementType[20];

   char                    Quantity[20];
   char                    Counterparty[20];
   char                    QuantityOfInstrument[20];
   char                    Instrument[20];






   counter=0;

   Field1 = strtok( msgBuffer, buf2);

   while( Field1)
      {
      counter++;

      strcpy( NewField[counter], Field1);
      printf( "NextField=%s\n", Field1);
      Field1 = strtok( NULL, buf2);
      }

   // Relate it to the specific fields ...
      strcpy (ExternalRef, NewField[1] );
         strcpy (PrepDateTime, NewField[2] );
            strcpy (LinkedTransaction, NewField[3] );
               strcpy (TransactionNo, NewField[4] );
                   strcpy (TradeDateTime, NewField[5] );
                          strcpy (DealPrice, NewField[6] );
                                strcpy (BuySell, NewField[7] );
                                       strcpy (SettlementType, NewField[8] );
                                               strcpy (Quantity, NewField[9] );
                                                    strcpy (Counterparty, NewField[10] );
                                                           strcpy (Instrument, NewField[11] );


  DisplayFAX( ExternalRef,
              PrepDateTime,
              LinkedTransaction,
              TransactionNo,
              TradeDateTime,
              DealPrice,
              BuySell,
              SettlementType,
              Quantity,
              Counterparty,
              Instrument );

}
//=============================================================================================
void DisplayFAX(char* ExternalRef,
                char* PrepDateTime,
                char* LinkedTransaction,
                char* TransactionNo,
                char* TradeDateTime,
                char* DealPrice,
                char* BuySell,
                char* SettlementType,
                char* Quantity,
                char* Counterparty,
                char* Instrument )
{

    int ch;
    fprintf(outFileStream,"\n%40.18s\n",
             "FAX MAPPING");

    fprintf(outFileStream,"   \n           _______________________________________________________\n");
    fprintf(outFileStream,"   \n           FAX                                                    \n");
    fprintf(outFileStream,"   \n           _______________________________________________________\n");
    fprintf(outFileStream,"   \n           Confirmation of Trade                                  \n");
    fprintf(outFileStream,"   \n                                                                  \n");
    fprintf(outFileStream,"   \n           To:                         Hill Samuel                    \n");
    fprintf(outFileStream,"   \n           FOR THE ATTENTION OF:       Mr. John Frederick             \n");
    fprintf(outFileStream,"   \n                                                                  \n");
    fprintf(outFileStream,"   \n           FAX NUMBER:                 0171-365-9985                  \n");
    fprintf(outFileStream,"   \n                                                                  \n");
    fprintf(outFileStream,"   \n           FROM:                       George Hamilton                \n");
    fprintf(outFileStream,"   \n                                       ABC Bank                       \n");
    fprintf(outFileStream,"   \n                                                                  \n");
    fprintf(outFileStream,"   \n           SENDER'S REFERENCE:         %s                         \n", ExternalRef);
    fprintf(outFileStream,"   \n           PREPARATION DATE/TIME:      %s                         \n", PrepDateTime);
    fprintf(outFileStream,"   \n           LINKED TRANSACTION:         %s                         \n", LinkedTransaction);
    fprintf(outFileStream,"   \n           TRANSACTION NO:             %s                         \n", TransactionNo);
    fprintf(outFileStream,"   \n           TRADE DATE/TIME:            %s                         \n", TradeDateTime);
    fprintf(outFileStream,"   \n           DEAL PRICE:                 %s                         \n", DealPrice);
    fprintf(outFileStream,"   \n           BUY/SELL:                   %s                         \n", BuySell);
    fprintf(outFileStream,"   \n           SETTLEMENT TYPE:            %s                         \n", SettlementType);
    fprintf(outFileStream,"   \n           COUNTERPARTY: BUYER:        %s                         \n", Counterparty);
    fprintf(outFileStream,"   \n           QUANTITY OF INSTRUMENT:     %s                         \n", Quantity);
    fprintf(outFileStream,"   \n           ISIN ID OF INSTRUMENT:      %s                         \n", Instrument );
    fprintf(outFileStream,"   \n           _______________________________________________________\n");


      // Check for the key that has been pressed.
/*        for ( ; ; ) {
          while (0 ==_kbhit() ) {
          }
          ch = _getch();

          if (49 == ch || 50 )
            exit(0);
         }
*/
}
//********************************************************************
//
// M A I N
//
//********************************************************************

int main(int argc, char * * argv)
{
   char   inputQueueName[100] ;


   //Open the output filename to receive debug messages
   if ((outFileStream = fopen(outFile, "w")) == NULL )
     return -1;

   if (argc == 1)
   {
     // No parameters have been passed at all
     fprintf( outFileStream, "MQIMQWF.EXE Error: No input queue name has been specified\n");
     exit(-1);
   }

   // Obtain the path to the queue configuration from the parameter
   strcpy(inputQueueName, argv[1]);

   printf("InputQueueName is : %s\n", inputQueueName);
   fprintf(outFileStream, "InputQueueName is : %s\n\n", inputQueueName);

   // Retrieve the message from the queue
   retrieveMessage();


   fprintf( outFileStream, "\nFinished processing\n");

   fclose(outFileStream);

   return( 0 );
}

