/********************************************************************/
/*                                                                  */
/* Program name: BackendSWIFT                                       */
/*                                                                  */
/* Description: This is a Backend application program.              */

/* Written  :   16/09/1999 Humayon Salim                            */
/*                                                                  */
/********************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <iostream.h>

//MQ header
#include <imqi.hpp>

//********************************************************************
// G L O B A L   D A T A   A N D   F U N C T I O N S
//********************************************************************

#define TRUE  1
#define FALSE 0
#define DELAY 5000

 char   pauseNow[1];
//input structure of the incoming message
typedef struct
{
   char processName[50];
   char processInput[950];
} PROCESS_TRIGGER_DATA;

PROCESS_TRIGGER_DATA processTriggerData;

FILE*            outFileStream;
char*            outFile = "BackendSWIFT.out";

//*******************************************************************
//
// Delay
//
//*******************************************************************
void delay (void)
{
  long x;
  for (x=0; x < DELAY; x++)
     ;
}

//*******************************************************************
//
// ClearScreen
//
//*******************************************************************

void ClearScreen()
{

   int count;

   for(count=1; count <=23; count++)
      printf("\n");
}
//*******************************************************************
//
// RETRIEVE MESSAGE
// This function retrieves the message from QUEUE1 and displays it
// on the screen.
//*******************************************************************

void retrieveMessage()
{
  ImqQueueManager         QMgr;             // Queue manager
  ImqQueue                queue;            // Queue
  ImqMessage              msg;              // MQ message
  ImqGetMessageOptions    getMsgOptions;    // Get message options

  char                    msgBuffer[1001];  // buffer for message data

  int                     getContinue;       // flag

  char                    a;

  fprintf( outFileStream, "\n================Bscreen1(Back-end) - Start of MQSeries Log ===================\n");

  // Connect to the local queue manager
  if ( ! QMgr.connect( ) )
  {
     /* stop if it failed     */
     fprintf( outFileStream, "ImqQueueManager::connect failed with reason code %ld\n",
             QMgr.reasonCode( ) );
     exit(-1);
  }

  // Now we open the input queue
  queue.setName("SWIFT_BACKEND_QUEUE") ;
  queue.setConnectionReference(QMgr);
  queue.setOpenOptions( MQOO_INPUT_SHARED ) ;
  if ( ! queue.open() )
  {
     fprintf( outFileStream, "\nImqQueue::open ended with reason code %ld\n", queue.reasonCode());
     exit(-1);
  }

  //define where the message data should be put
  msg.useEmptyBuffer(msgBuffer, sizeof(msgBuffer) - 1);

  //set up the get message options
  getMsgOptions.setOptions( MQGMO_WAIT );
  getMsgOptions.setWaitInterval( MQWI_UNLIMITED );

  getContinue = TRUE;



     printf("===========================================================================\n");
     printf("\n New Message..                                                           \n");
     printf("===========================================================================\n");
     fprintf(outFileStream, "\n New message retrieved from queue: SWIFT_BACKEND_QUEUE .\n");

     // reset the message and correl ids.
     msg.setMessageId( (MQBYTE*)MQMI_NONE );
     msg.setCorrelationId( (MQBYTE*)MQMI_NONE );

     if ( ! queue.get( msg, getMsgOptions ))
     {
        //the get didn't work for some reason
        fprintf(outFileStream, "\nImqQueue::get ended with reason code %ld\n",
                                                        queue.reasonCode());
        getContinue = FALSE;
     }
     else
     {
        //the get of the reply msg worked
        printf("========================================================================\n");
        printf("            Message Content: %s\n", msgBuffer);
        printf("========================================================================\n");

        fprintf( outFileStream, "\n2)The message is : %s\n", msgBuffer);


        // move message buffer into appropriate structure
        memcpy(&processTriggerData, msgBuffer, 1000);


        //finally re-initialize the processTriggerData structure
        memset(&processTriggerData, '\0', 1000);
     }
     fflush(outFileStream);


  if ( ! queue.close( ) )
  {
     fprintf( outFileStream, "\nImqQueue::close ended with reason code %ld\n",
                                                       queue.reasonCode());
     exit(-1);
  }
}
//=============================================================================================
void DisplaySWIFT()
{


}
//********************************************************************
//
// M A I N
//
//********************************************************************

int main(int argc, char * * argv)
{
   char   inputQueueName[100] ;



   //Open the output filename to receive debug messages
   if ((outFileStream = fopen(outFile, "w")) == NULL )
     return -1;

   if (argc == 1)
   {
     // No parameters have been passed at all
     fprintf( outFileStream, "MQIMQWF.EXE Error: No input queue name has been specified\n");
     exit(-1);
   }

   // Obtain the path to the queue configuration from the parameter
   strcpy(inputQueueName, argv[1]);

   printf("InputQueueName is : %s\n", inputQueueName);
   fprintf(outFileStream, "InputQueueName is : %s\n\n", inputQueueName);

   // Clear the screen
   ClearScreen();

   // Retrieve the message from the queue
   retrieveMessage();

   fprintf( outFileStream, "\nFinished processing\n");

   fclose(outFileStream);

   return( 0 );
}

