/********************************************************************/
/*                                                                  */
/* Program name: TestDecision1                                      */
/*                                                                  */
/* Description: This is an MQ Workflow API program.                 */
/*                                                                  */
/* Written  :   12/08/99 Humayon Salim                              */
/*                                                                  */
/********************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <iostream.h>
#include <conio.h>

#include <bool.h>
#include <vector.h>
#include <fmcjccon.h>
#include <fmcjcrun.h>
#include <windows.h>

//MQ header
#include <imqi.hpp>
// MQ Workflow header
#include "exmwjapc.h"

//********************************************************************
// G L O B A L   D A T A   A N D   F U N C T I O N S
//********************************************************************

//backend destination definition
//Defines the name of the backend program that will service the message
//and the queue name to be used to route the information there.

struct policy
{
  char number[6],
       type[5];
};

typedef struct
{
  char retCode[2],
       custNum[6],
       noOfPolicies[2];
  struct policy list[10];
} CUSTPOLS_COMMAREA;

struct policy_type
{
  char policyType[5],
       programName[8],
       RTQ[48],
       noOfPolicies[1],
       policyNumbers[3][6];
} ;


typedef struct
{
   char processName[50];
   char processInput[950];
} PROCESS_TRIGGER_DATA;


PROCESS_TRIGGER_DATA processTriggerData;

CUSTPOLS_COMMAREA custpolsCommarea;

FILE*            outFileStream;
char*            outFile = "TestDecision1.out";

char MessageId[24];

void MoveData ( FmcjReadOnlyContainerHandle ,
                FmcjReadWriteContainerHandle );

// =============================================================================================
void GetMessageType()
{

  FmcjReadOnlyContainerHandle input = 0;
  FmcjReadWriteContainerHandle output = 0;
  char programID [ FMC_PEAPROG_CORRELID_LENGTH ] = "";
  APIRET rc;

/*--------------------------------------------------------------------*\
| Connect                                                              |
\*--------------------------------------------------------------------*/

  FmcjGlobalConnect ( );

 fprintf( outFileStream, "\n================ Start of MQSeries Workflow ===================\n");

/*--------------------------------------------------------------------*\
| Retrieve program ID                                                  |
\*--------------------------------------------------------------------*/

  FmcjPEAProgramID ( programID, FMC_PEAPROG_CORRELID_LENGTH );

/*--------------------------------------------------------------------*\
| Retrieve input container                                             |
\*--------------------------------------------------------------------*/

  rc = FmcjContainerInContainer ( &input );
  if ( rc != FMC_OK )
    fprintf ( outFileStream, "\nInContainer failed with rc = %u\n", rc );
  else
    fprintf ( outFileStream, "\nInContainer was successful !\n" );

/*--------------------------------------------------------------------*\
| Retrieve output container                                            |
\*--------------------------------------------------------------------*/

  rc = FmcjContainerOutContainer ( &output );
  if ( rc != FMC_OK )
    fprintf ( outFileStream, "\nOutContainer failed with rc = %u\n", rc );
  else
    fprintf ( outFileStream, "\nOutContainer was successful !\n" );

/*--------------------------------------------------------------------*\
| Move data from input to output container                             |
\*--------------------------------------------------------------------*/

  MoveData ( input, output );

/*--------------------------------------------------------------------*\
| Store output container                                               |
\*--------------------------------------------------------------------*/

  rc = FmcjContainerSetOutContainer ( output );
  if ( rc != FMC_OK )
    fprintf ( outFileStream, "\nSetOutContainer failed with rc = %u\n", rc );
  else
    fprintf ( outFileStream, "\nSetOutContainer was successful !\n" );

/*--------------------------------------------------------------------*\
| Disconnect                                                           |
\*--------------------------------------------------------------------*/

  FmcjGlobalDisconnect ( );

  fprintf( outFileStream, "\n================ End of MQSeries Workflow ===================\n");
}

// ===================================================================================

void MoveData ( FmcjReadOnlyContainerHandle  input ,
                FmcjReadWriteContainerHandle output )
{
 char MessageType [ 20 ];
  char TradeDealFlag [ 5 ];
  APIRET rc;

    char                    Counterparty[10];
    char                    InternalRef[20];
    char                    ExternalRef[20];


    char                    ISIN [10];
    char                    ISINnumber[20];
    char                    InstrumentName[45];

    char                    BuySell [5];
    char                    Qty[20];
    char                    Price[20];
    char                    Currency [4] ;
    char                    Net[20];
    char                    Status[10];

    char                    TradeType[12];
    char                    Book[8];
    char                    Market[8];

    char                    SettlementType[30];


    char                    TradeDate[10];
    char                    TradeTime[6];
    char                    SettlementDate[10];

    char                    DepotShortName[30];
    char                    DepotLongName[80];

    char                    NostrosShortName[30];
    char                    NostrosLongName[80];


/*--------------------------------------------------------------------*\
| display input container member                                       |
\*--------------------------------------------------------------------*/

  rc = FmcjReadOnlyContainerStringValue ( input,
                                          "MessageType",
                                          MessageType,
                                          20);
  if ( rc != FMC_OK )
    fprintf ( outFileStream,"\nRetrieval of MessageType failed with rc = %u\n", rc );
  else
    fprintf ( outFileStream, "\nMessageType = %s\n", MessageType );

/*--------------------------------------------------------------------*\
| display input container member                                       |
\*--------------------------------------------------------------------*/

  rc = FmcjReadOnlyContainerStringValue ( input,
                                          "TradeDealFlag",
                                          TradeDealFlag,
                                          5);
  if ( rc != FMC_OK )
    fprintf ( outFileStream,"\nRetrieval of TradeDealFlag failed with rc = %u\n", rc );
  else
    fprintf ( outFileStream, "\nTradeDealFlag = %s\n", TradeDealFlag );

/*--------------------------------------------------------------------*\
| display input container member                                       |
\*--------------------------------------------------------------------*/

  rc = FmcjReadOnlyContainerStringValue ( input,
                                          "Counterparty",
                                          Counterparty,
                                          10);
  if ( rc != FMC_OK )
    fprintf ( outFileStream,"\nRetrieval of Counterparty failed with rc = %u\n", rc );
  else
    fprintf ( outFileStream, "\nCounterparty = %s\n", Counterparty );

/*--------------------------------------------------------------------*\
| display input container member                                       |
\*--------------------------------------------------------------------*/

  rc =  FmcjReadOnlyContainerStringValue( input,
                                        "InternalRef",
                                        InternalRef,
                                         20 );
  if ( rc != FMC_OK )
    fprintf ( outFileStream,"\nRetrieval of InternalRef failed with rc = %u\n", rc );
  else
    fprintf ( outFileStream, "\nInternalRef = %s\n", InternalRef );

/*--------------------------------------------------------------------*\
| display input container member                                       |
\*--------------------------------------------------------------------*/

  rc =  FmcjReadOnlyContainerStringValue( input,
                                        "ExternalRef",
                                        ExternalRef,
                                         20 );
  if ( rc != FMC_OK )
    fprintf ( outFileStream,"\nRetrieval of ExternalRef failed with rc = %u\n", rc );
  else
    fprintf ( outFileStream, "\nExternalRef = %s\n", ExternalRef );

/*--------------------------------------------------------------------*\
| display input container member                                       |
\*--------------------------------------------------------------------*/

  rc = FmcjReadOnlyContainerStringValue ( input,
                                          "ISIN",
                                          ISIN,
                                          5);
  if ( rc != FMC_OK )
    fprintf ( outFileStream,"\nRetrieval of ISIN failed with rc = %u\n", rc );
  else
    fprintf ( outFileStream, "\nISIN = %s\n", ISIN );

/*--------------------------------------------------------------------*\
| display input container member                                       |
\*--------------------------------------------------------------------*/

  rc = FmcjReadOnlyContainerStringValue ( input,
                                          "ISINnumber",
                                          ISINnumber,
                                          20);
  if ( rc != FMC_OK )
    fprintf ( outFileStream,"\nRetrieval of ISINnumber failed with rc = %u\n", rc );
  else
    fprintf ( outFileStream, "\nISINnumber = %s\n", ISINnumber );

/*--------------------------------------------------------------------*\
| display input container member                                       |
\*--------------------------------------------------------------------*/

  rc = FmcjReadOnlyContainerStringValue ( input,
                                          "InstrumentName",
                                          InstrumentName,
                                          45);
  if ( rc != FMC_OK )
    fprintf ( outFileStream,"\nRetrieval of InstrumentName failed with rc = %u\n", rc );
  else
    fprintf ( outFileStream, "\nInstrumentName = %s\n", InstrumentName );

/*--------------------------------------------------------------------*\
| display input container member                                       |
\*--------------------------------------------------------------------*/

  rc = FmcjReadOnlyContainerStringValue ( input,
                                          "BuySell",
                                          BuySell,
                                          5);
  if ( rc != FMC_OK )
    fprintf ( outFileStream,"\nRetrieval of BuySell failed with rc = %u\n", rc );
  else
    fprintf ( outFileStream, "\nBuySell = %s\n", BuySell );


/*--------------------------------------------------------------------*\
| display input container member                                       |
\*--------------------------------------------------------------------*/

  rc =  FmcjReadOnlyContainerStringValue( input,
                                        "Qty",
                                        Qty,
                                        20  );
  if ( rc != FMC_OK )
    fprintf ( outFileStream,"\nRetrieval of Qty failed with rc = %u\n", rc );
  else
    fprintf ( outFileStream, "\nQty = %s\n", Qty );


/*--------------------------------------------------------------------*\
| display input container member                                       |
\*--------------------------------------------------------------------*/

  rc =  FmcjReadOnlyContainerStringValue( input,
                                        "Price",
                                        Price,
                                        20  );
  if ( rc != FMC_OK )
    fprintf ( outFileStream,"\nRetrieval of Price failed with rc = %u\n", rc );
  else
    fprintf ( outFileStream, "\nPrice = %s\n", Price );


/*--------------------------------------------------------------------*\
| display input container member                                       |
\*--------------------------------------------------------------------*/

  rc = FmcjReadOnlyContainerStringValue ( input,
                                          "Currency",
                                          Currency,
                                          4);
  if ( rc != FMC_OK )
    fprintf ( outFileStream,"\nRetrieval of Currency failed with rc = %u\n", rc );
  else
    fprintf ( outFileStream, "\nCurrency = %s\n", Currency );

/*--------------------------------------------------------------------*\
| display input container member                                       |
\*--------------------------------------------------------------------*/

  rc =  FmcjReadOnlyContainerStringValue( input,
                                        "Net",
                                        Net,
                                         20 );
  if ( rc != FMC_OK )
    fprintf ( outFileStream,"\nRetrieval of Net failed with rc = %u\n", rc );
  else
    fprintf ( outFileStream, "\nNet = %s\n", Net );


/*--------------------------------------------------------------------*\
| display input container member                                       |
\*--------------------------------------------------------------------*/

  rc = FmcjReadOnlyContainerStringValue ( input,
                                          "Status",
                                          Status,
                                          10);
  if ( rc != FMC_OK )
    fprintf ( outFileStream,"\nRetrieval of Status failed with rc = %u\n", rc );
  else
    fprintf ( outFileStream, "\nStatus = %s\n", Status );

/*--------------------------------------------------------------------*\
| display input container member                                       |
\*--------------------------------------------------------------------*/

  rc = FmcjReadOnlyContainerStringValue ( input,
                                          "TradeType",
                                          TradeType,
                                          12);
  if ( rc != FMC_OK )
    fprintf ( outFileStream,"\nRetrieval of TradeType failed with rc = %u\n", rc );
  else
    fprintf ( outFileStream, "\nTradeType = %s\n", TradeType );

/*--------------------------------------------------------------------*\
| display input container member                                       |
\*--------------------------------------------------------------------*/

  rc = FmcjReadOnlyContainerStringValue ( input,
                                          "Book",
                                          Book,
                                           8);
  if ( rc != FMC_OK )
    fprintf ( outFileStream,"\nRetrieval of Book failed with rc = %u\n", rc );
  else
    fprintf ( outFileStream, "\nBook = %s\n", Book );


/*--------------------------------------------------------------------*\
| display input container member                                       |
\*--------------------------------------------------------------------*/

  rc = FmcjReadOnlyContainerStringValue ( input,
                                          "Market",
                                          Market,
                                           8);
  if ( rc != FMC_OK )
    fprintf ( outFileStream,"\nRetrieval of Market failed with rc = %u\n", rc );
  else
    fprintf ( outFileStream, "\nMarket = %s\n", Market );

/*--------------------------------------------------------------------*\
| display input container member                                       |
\*--------------------------------------------------------------------*/

  rc = FmcjReadOnlyContainerStringValue ( input,
                                          "SettlementType",
                                          SettlementType,
                                           30);
  if ( rc != FMC_OK )
    fprintf ( outFileStream,"\nRetrieval of SettlementType failed with rc = %u\n", rc );
  else
    fprintf ( outFileStream, "\nSettlementType = %s\n", SettlementType );


/*--------------------------------------------------------------------*\
| display input container member                                       |
\*--------------------------------------------------------------------*/

  rc = FmcjReadOnlyContainerStringValue ( input,
                                          "TradeDate",
                                          TradeDate,
                                           10);
  if ( rc != FMC_OK )
    fprintf ( outFileStream,"\nRetrieval of TradeDate failed with rc = %u\n", rc );
  else
    fprintf ( outFileStream, "\nTradeDate = %s\n", TradeDate );

/*--------------------------------------------------------------------*\
| display input container member                                       |
\*--------------------------------------------------------------------*/

  rc = FmcjReadOnlyContainerStringValue ( input,
                                          "TradeTime",
                                          TradeTime,
                                           6);
  if ( rc != FMC_OK )
    fprintf ( outFileStream,"\nRetrieval of TradeTime failed with rc = %u\n", rc );
  else
    fprintf ( outFileStream, "\nTradeTime = %s\n", TradeTime );


/*--------------------------------------------------------------------*\
| display input container member                                       |
\*--------------------------------------------------------------------*/

  rc = FmcjReadOnlyContainerStringValue ( input,
                                          "SettlementDate",
                                          SettlementDate,
                                           10);
  if ( rc != FMC_OK )
    fprintf ( outFileStream,"\nRetrieval of SettlementDate failed with rc = %u\n", rc );
  else
    fprintf ( outFileStream, "\nSettlementDate = %s\n", SettlementDate );

/*--------------------------------------------------------------------*\
| display input container member                                       |
\*--------------------------------------------------------------------*/

  rc = FmcjReadOnlyContainerStringValue ( input,
                                          "DepotShortName",
                                          DepotShortName,
                                           30);
  if ( rc != FMC_OK )
    fprintf ( outFileStream,"\nRetrieval of DepotShortName failed with rc = %u\n", rc );
  else
    fprintf ( outFileStream, "\nDepotShortName = %s\n", DepotShortName );

/*--------------------------------------------------------------------*\
| display input container member                                       |
\*--------------------------------------------------------------------*/

  rc = FmcjReadOnlyContainerStringValue ( input,
                                          "DepotLongName",
                                          DepotLongName,
                                           80);
  if ( rc != FMC_OK )
    fprintf ( outFileStream,"\nRetrieval of DepotLongName failed with rc = %u\n", rc );
  else
    fprintf ( outFileStream, "\nDepotLongName = %s\n", DepotLongName );

/*--------------------------------------------------------------------*\
| display input container member                                       |
\*--------------------------------------------------------------------*/

  rc = FmcjReadOnlyContainerStringValue ( input,
                                          "NostrosShortName",
                                          NostrosShortName,
                                           30);
  if ( rc != FMC_OK )
    fprintf ( outFileStream,"\nRetrieval of NostrosShortName failed with rc = %u\n", rc );
  else
    fprintf ( outFileStream, "\nNostrosShortName = %s\n", NostrosShortName );

/*--------------------------------------------------------------------*\
| display input container member                                       |
\*--------------------------------------------------------------------*/

  rc = FmcjReadOnlyContainerStringValue ( input,
                                          "NostrosLongName",
                                          NostrosLongName,
                                           80);
  if ( rc != FMC_OK )
    fprintf ( outFileStream,"\nRetrieval of NostrosLongName failed with rc = %u\n", rc );
  else
    fprintf ( outFileStream, "\nNostrosLongName = %s\n", NostrosLongName );



/*--------------------------------------------------------------------*\
| write values to output container members                             |
\*--------------------------------------------------------------------*/

  rc = FmcjReadWriteContainerSetStringValue ( output,
                                              "MessageType",
                                              MessageType );
  if ( rc != FMC_OK )
    fprintf ( outFileStream, "\n Writing of MessageType failed with rc = %u\n", rc );
  else
    fprintf ( outFileStream, "\n Writing of MessageType was successfull.\n" );



/*--------------------------------------------------------------------*\
| write values to output container members                             |
\*--------------------------------------------------------------------*/

  rc = FmcjReadWriteContainerSetStringValue ( output,
                                              "TradeDealFlag",
                                              TradeDealFlag );
  if ( rc != FMC_OK )
    fprintf ( outFileStream, "\n Writing of TradeDealFlag failed with rc = %u\n", rc );
  else
    fprintf ( outFileStream, "\n Writing of TradeDealFlag was successfull.\n");

/*--------------------------------------------------------------------*\
| write values to output container members                             |
\*--------------------------------------------------------------------*/

  rc = FmcjReadWriteContainerSetStringValue ( output,
                                              "Counterparty",
                                              Counterparty );
  if ( rc != FMC_OK )
    fprintf ( outFileStream, "\nWriting of Counterparty failed with rc = %u\n", rc );
  else
    fprintf ( outFileStream, "\nWriting of Counterparty was successfull.\n" );

/*--------------------------------------------------------------------*\
| write values to output container members                             |
\*--------------------------------------------------------------------*/

  rc = FmcjReadWriteContainerSetStringValue ( output,
                                            "InternalRef",
                                            InternalRef );
  if ( rc != FMC_OK )
    fprintf ( outFileStream, "\nWriting of InternalRef failed with rc = %u\n", rc );
  else
    fprintf ( outFileStream, "\nWriting of InternalRef was successfull.\n" );

/*--------------------------------------------------------------------*\
| write values to output container members                             |
\*--------------------------------------------------------------------*/

  rc = FmcjReadWriteContainerSetStringValue ( output,
                                           "ExternalRef",
                                            ExternalRef );
  if ( rc != FMC_OK )
    fprintf ( outFileStream, "\nWriting of ExternalRef failed with rc = %u\n", rc );
  else
    fprintf ( outFileStream, "\nWriting of ExternalRef was successfull.\n" );

/*--------------------------------------------------------------------*\
| write values to output container members                             |
\*--------------------------------------------------------------------*/

  rc = FmcjReadWriteContainerSetStringValue ( output,
                                              "ISIN",
                                              ISIN );
  if ( rc != FMC_OK )
    fprintf ( outFileStream, "\nWriting of ISIN failed with rc = %u\n", rc );
  else
    fprintf ( outFileStream, "\nWriting of ISIN was successfull.\n" );

/*--------------------------------------------------------------------*\
| write values to output container members                             |
\*--------------------------------------------------------------------*/

  rc = FmcjReadWriteContainerSetStringValue ( output,
                                              "ISINnumber",
                                              ISINnumber );
  if ( rc != FMC_OK )
    fprintf ( outFileStream, "\nWriting of ISINnumber failed with rc = %u\n", rc );
  else
    fprintf ( outFileStream, "\nWriting of ISINnumber was successfull.\n" );

/*--------------------------------------------------------------------*\
| write values to output container members                             |
\*--------------------------------------------------------------------*/

  rc = FmcjReadWriteContainerSetStringValue ( output,
                                              "InstrumentName",
                                              InstrumentName );
  if ( rc != FMC_OK )
    fprintf ( outFileStream, "\nWriting of InstrumentName failed with rc = %u\n", rc );
  else
    fprintf ( outFileStream, "\nWriting of InstrumentName was successfull.\n" );

/*--------------------------------------------------------------------*\
| write values to output container members                             |
\*--------------------------------------------------------------------*/

  rc = FmcjReadWriteContainerSetStringValue ( output,
                                              "BuySell",
                                              BuySell );
  if ( rc != FMC_OK )
    fprintf ( outFileStream, "\nWriting of BuySell failed with rc = %u\n", rc );
  else
    fprintf ( outFileStream, "\nWriting of BuySell was successfull.\n" );


/*--------------------------------------------------------------------*\
| write values to output container members                             |
\*--------------------------------------------------------------------*/

  rc = FmcjReadWriteContainerSetStringValue ( output,
                                            "Qty",
                                            Qty );
  if ( rc != FMC_OK )
    fprintf ( outFileStream, "\nWriting of Qty failed with rc = %u\n", rc );
  else
    fprintf ( outFileStream, "\nWriting of Qty was successfull.\n" );

/*--------------------------------------------------------------------*\
| write values to output container members                             |
\*--------------------------------------------------------------------*/

  rc = FmcjReadWriteContainerSetStringValue ( output,
                                              "Price",
                                              Price );
  if ( rc != FMC_OK )
    fprintf ( outFileStream, "\nWriting of Price failed with rc = %u\n", rc );
  else
    fprintf ( outFileStream, "\nWriting of Price was successfull.\n" );

/*--------------------------------------------------------------------*\
| write values to output container members                             |
\*--------------------------------------------------------------------*/

  rc = FmcjReadWriteContainerSetStringValue ( output,
                                              "Currency",
                                              Currency );
  if ( rc != FMC_OK )
    fprintf ( outFileStream, "\nWriting of Currency failed with rc = %u\n", rc );
  else
    fprintf ( outFileStream, "\nWriting of Currency was successfull.\n" );

/*--------------------------------------------------------------------*\
| write values to output container members                             |
\*--------------------------------------------------------------------*/

  rc = FmcjReadWriteContainerSetStringValue ( output,
                                              "Net",
                                              Net );
  if ( rc != FMC_OK )
    fprintf ( outFileStream, "\nWriting of Net failed with rc = %u\n", rc );
  else
    fprintf ( outFileStream, "\nWriting of Net was successfull.\n" );

/*--------------------------------------------------------------------*\
| write values to output container members                             |
\*--------------------------------------------------------------------*/

  rc = FmcjReadWriteContainerSetStringValue ( output,
                                              "Status",
                                              Status );
  if ( rc != FMC_OK )
    fprintf ( outFileStream, "\nWriting of Status failed with rc = %u\n", rc );
  else
    fprintf ( outFileStream, "\nWriting of Status was successfull.\n" );

/*--------------------------------------------------------------------*\
| write values to output container members                             |
\*--------------------------------------------------------------------*/

  rc = FmcjReadWriteContainerSetStringValue ( output,
                                              "TradeType",
                                              TradeType );
  if ( rc != FMC_OK )
    fprintf ( outFileStream, "\nWriting of TradeType failed with rc = %u\n", rc );
  else
    fprintf ( outFileStream, "\nWriting of TradeType was successfull.\n" );

/*--------------------------------------------------------------------*\
| write values to output container members                             |
\*--------------------------------------------------------------------*/

  rc = FmcjReadWriteContainerSetStringValue ( output,
                                              "Book",
                                              Book );
  if ( rc != FMC_OK )
    fprintf ( outFileStream, "\nWriting of Book failed with rc = %u\n", rc );
  else
    fprintf ( outFileStream, "\nWriting of Book was successfull.\n" );

/*--------------------------------------------------------------------*\
| write values to output container members                             |
\*--------------------------------------------------------------------*/

  rc = FmcjReadWriteContainerSetStringValue ( output,
                                              "Market",
                                              Market );
  if ( rc != FMC_OK )
    fprintf ( outFileStream, "\nWriting of Market failed with rc = %u\n", rc );
  else
    fprintf ( outFileStream, "\nWriting of Market was successfull.\n" );

/*--------------------------------------------------------------------*\
| write values to output container members                             |
\*--------------------------------------------------------------------*/

  rc = FmcjReadWriteContainerSetStringValue ( output,
                                              "SettlementType",
                                              SettlementType );
  if ( rc != FMC_OK )
    fprintf ( outFileStream, "\nWriting of SettlementType failed with rc = %u\n", rc );
  else
    fprintf ( outFileStream, "\nWriting of SettlementType was successfull.\n" );

/*--------------------------------------------------------------------*\
| write values to output container members                             |
\*--------------------------------------------------------------------*/

  rc = FmcjReadWriteContainerSetStringValue ( output,
                                              "TradeDate",
                                              TradeDate );
  if ( rc != FMC_OK )
    fprintf ( outFileStream, "\nWriting of TradeDate failed with rc = %u\n", rc );
  else
    fprintf ( outFileStream, "\nWriting of TradeDate was successfull.\n" );

/*--------------------------------------------------------------------*\
| write values to output container members                             |
\*--------------------------------------------------------------------*/

  rc = FmcjReadWriteContainerSetStringValue ( output,
                                              "TradeTime",
                                              TradeTime );
  if ( rc != FMC_OK )
    fprintf ( outFileStream, "\nWriting of TradeTime failed with rc = %u\n", rc );
  else
    fprintf ( outFileStream, "\nWriting of TradeTime was successfull.\n" );

/*--------------------------------------------------------------------*\
| write values to output container members                             |
\*--------------------------------------------------------------------*/

  rc = FmcjReadWriteContainerSetStringValue ( output,
                                              "SettlementDate",
                                              SettlementDate );
  if ( rc != FMC_OK )
    fprintf ( outFileStream, "\nWriting of SettlementDate failed with rc = %u\n", rc );
  else
    fprintf ( outFileStream, "\nWriting of SettlementDate was successfull.\n" );

/*--------------------------------------------------------------------*\
| write values to output container members                             |
\*--------------------------------------------------------------------*/

  rc = FmcjReadWriteContainerSetStringValue ( output,
                                              "DepotShortName",
                                              DepotShortName );
  if ( rc != FMC_OK )
    fprintf ( outFileStream, "\nWriting of DepotShortName failed with rc = %u\n", rc );
  else
    fprintf ( outFileStream, "\nWriting of DepotShortName was successfull.\n" );

/*--------------------------------------------------------------------*\
| write values to output container members                             |
\*--------------------------------------------------------------------*/

  rc = FmcjReadWriteContainerSetStringValue ( output,
                                              "DepotLongName",
                                              DepotLongName );
  if ( rc != FMC_OK )
    fprintf ( outFileStream, "\nWriting of DepotLongName failed with rc = %u\n", rc );
  else
    fprintf ( outFileStream, "\nWriting of DepotLongName was successfull.\n" );

/*--------------------------------------------------------------------*\
| write values to output container members                             |
\*--------------------------------------------------------------------*/

  rc = FmcjReadWriteContainerSetStringValue ( output,
                                              "NostrosShortName",
                                              NostrosShortName );
  if ( rc != FMC_OK )
    fprintf ( outFileStream, "\nWriting of NostrosShortName failed with rc = %u\n", rc );
  else
    fprintf ( outFileStream, "\nWriting of NostrosShortName was successfull.\n" );

/*--------------------------------------------------------------------*\
| write values to output container members                             |
\*--------------------------------------------------------------------*/

  rc = FmcjReadWriteContainerSetStringValue ( output,
                                              "NostrosLongName",
                                              NostrosLongName );
  if ( rc != FMC_OK )
    fprintf ( outFileStream, "\nWriting of NostrosLongName failed with rc = %u\n", rc );
  else
    fprintf ( outFileStream, "\nWriting of NostrosLongName was successfull.\n" );

}

//==============================================================================================================

void PopDataOutContainer()
{
/*--------------------------------------------------------------------*\
| Global Data                                                          |
\*--------------------------------------------------------------------*/

char * pSessionId = 0;

/*--------------------------------------------------------------------*\
| function prototypes                                                  |
\*--------------------------------------------------------------------*/

  int              i;
  unsigned long    length;


/*--------------------------------------------------------------------*\
|                   Screen 1 fields                                    |
\*--------------------------------------------------------------------*/

   long              ClientID;
   char*             InsuredName;
   char*             Address;
   char*             PolicyReference;
   char*             VehicleDescription;

   RETURNCODE       Rc1;
   char             Buf[ EXMPJ_SESS_BUF_LEN ];

   // Display start of MQSeries log...
   fprintf( outFileStream, "\n================Start of MQSeries Workflow Log ===================\n");

/*--------------------------------------------------------------------*\
| Allocate memory                                                     |
\*--------------------------------------------------------------------*/

  Rc1 = ExmcStartApi();
  if ( Rc1 != EXMPJ_OK )
  {
    fprintf( outFileStream, "\nMemory allocation failed\n" );
   } else {
    fprintf( outFileStream, "\nSuccessfully allocated Memory allocation.\n" );
    }

/*--------------------------------------------------------------------*\
| Delay first API until program is registered by Execution Client      |
\*--------------------------------------------------------------------*/

  Rc1 = ExmcInit();
  if ( Rc1 != EXMPJ_OK )
  {
    fprintf( outFileStream, "\nInitialization failed\n" );
   } else {
    fprintf( outFileStream, "\nInitialisation was successful.\n" );
    }


/*--------------------------------------------------------------------*\
| Set the output container item                                       |
\*--------------------------------------------------------------------*/


  InsuredName = "YES";
  length = sizeof( InsuredName );

  Rc1 = ExmcSetContainerItem2(pSessionId,
                             "TradeDealFlag",
                             length,
                             InsuredName);

  if ( Rc1 != EXMPJ_OK )
  {
    fprintf( outFileStream, "\nSet of SpecialDealFlag failed. Returned %ld\n", Rc1 );
    exit( -1 );
  }
  else
    fprintf( outFileStream, "\nSet of SpecialDealFlag completed successfully\n");


/*--------------------------------------------------------------------*\
| Clean up                                                             |
\*--------------------------------------------------------------------*/

  Rc1 = ExmcEnd2 ( pSessionId );
  Rc1 = ExmcFinishApi();


  // Display start of MQSeries log...
  fprintf( outFileStream, "\n================End of MQSeries Workflow Log ===================\n");


}

//=================================================================================================================
//*******************************************************************
//
// SendMessageToQueue
// This function takes the data from the end-user and is put on an
// MQSeries Queue.
//
//*******************************************************************

void SendMessageToQueue(ImqQueueManager* QMgr)
{
  ImqQueue queue;                        // Queue
  ImqMessage msg, replyMsg;              // MQ message
  int i, wait_time, noOfPoliciesInt;
  char messageData[128];                  // message data
  char replyMsgBuffer[129];               // buffer for reply message data
  char commAreaData[121], noOfPoliciesString[3], policyType[6];
  ImqGetMessageOptions getMsgOptions;
  char* stringData;
  int ch;
  int counter;

  //set the format of the message
  msg.setFormat( MQFMT_STRING );
  msg.setMessageType( MQMT_REQUEST );

  //set the name of the backend queue
  queue.setName("LOG_QUEUE");

  //set the name of the reply queue in the message
  msg.setReplyToQueueName("LOG_QUEUE");


  // Display the Visual application..
  STARTUPINFO si;
  PROCESS_INFORMATION pi;

  ZeroMemory ( &si, sizeof ( si ) ) ;

  si.cb = sizeof ( si )  ;

  if ( !CreateProcess ( NULL,
                        "CheckCrossCurrencyTrade",
                        NULL,
                        NULL,
                        FALSE,
                        0,
                        NULL,
                        NULL,
                        &si,
                       &pi )
       )

    ch = _getch();
   WaitForSingleObject ( pi.hProcess, INFINITE ) ;

 // Close process and thread handles
    CloseHandle (  pi.hProcess ) ;
    CloseHandle (  pi.hThread ) ;



  // set up the message to be sent
  // add the name of the Backend program to invoke.
  stringData = "Activity(100123, 2, 1, CheckCrossCurrencyTrade)";


  strcpy(messageData, stringData);


  strcat(messageData, (char*)&custpolsCommarea);

  // Display start of MQSeries log...
  fprintf( outFileStream, "\n================Start of MQSeries Log ===================\n");


  //DEBUG
  fprintf(outFileStream,"\n1) The Message has been sent to queue LOG_QUEUE.\n");
  fprintf(outFileStream,"\n2) The Message content is:   %s\n", messageData);

  //link the queue to the queue manager
  queue.setConnectionReference(QMgr);

  //set the open options to be used when opening the queue
  queue.setOpenOptions( MQOO_OUTPUT /* open queue for output        */
#if defined ( _IMQ_VER ) && ( _IMQ_VER >= 200 )
      + MQOO_FAIL_IF_QUIESCING
#endif
                       );     /* but not if MQM stopping      */

  if ( ! queue.open( ) )
  {
     fprintf( outFileStream, "ImqQueue::open ended with reason code %ld\n",
              queue.reasonCode( ) );
     exit( (int)queue.reasonCode( ) );
  }

  //tell the message where to get message data from
  msg.useFullBuffer(messageData, 128);

  // Put the message on the queue
  if ( ! queue.put( msg ) )
  {
     fprintf( outFileStream, "ImqQueue::put ended with reason code %ld\n",
             queue.reasonCode( ) );
     exit( (int)queue.reasonCode( ) );
  }

  //Close the queue
  if ( ! queue.close( ) )
  {
     /* report reason, if any     */
     fprintf( outFileStream, "ImqQueue::close ended with reason code %ld\n",
             queue.reasonCode( ) );
     exit( (int)queue.reasonCode( ) ) ;
  }

}
//==================================================================================================
//********************************************************************
//
// M A I N
//
//********************************************************************

int main(int argc, char * * argv)
{
   FILE* 		configFileStream;
   char* 		customerNumber;
   char 		configFile[100];
   ImqQueueManager 	QMgr;

   char*  pSessionId;   // session id required for MQ Workflow API calls


   //Open the output filename to receive debug messages
   if ((outFileStream = fopen(outFile, "w")) == NULL )
     return -1;



   //we now have the customer number. Now get all of the details from the backend application.
   // Connect to the local queue manager
   if ( ! QMgr.connect( ) )
   {
      /* stop if it failed     */
      fprintf( outFileStream, "ImqQueueManager::connect failed with reason code %ld\n",
              QMgr.reasonCode( ) );
      exit(-1);
   }


   // Put an MQ Message onto the appropriate queue to trigger a Backend app that will
   //return all of the backend program details.
    SendMessageToQueue(&QMgr);


     // Populate data into Workflow activity's output container
//   PopDataOutContainer();

   GetMessageType();


   // Disconnect from MQM
   if ( ! QMgr.disconnect( ) )
   {
      fprintf( outFileStream, "ImqQueueManager::disconnect failed with reason code %ld\n",
              QMgr.reasonCode( ) ); // report reason, if any
      exit(-1);
   }




   return( 0 );
}

