@echo off
title Reset MQSI Test Drive
REM #####################################################
REM # This is the reset for the MQI C++ TestDrive only  #
REM #####################################################
REM This file will attempt the following...
REM - delete MQ qmgr
REM - drop DB/2 database DBMSERV
REM - refresh the TestDrive directory

REM ### Setup ####
title Reset MQSI Test Drive
set DB2INSTANCE=DB2
set QMNAME=default2
set LOG=%TSDEMOPATH%\ResetMqsiTD.log
echo Log file = %LOG% 2>&1
echo Resetting the MQI C++ Test Drive... > %LOG% 2>&1


REM ------------------------------ MQ SECTION ------------------------------
echo. >> %LOG% 2>&1
echo.
echo MQ Section
echo ---------- MQ section ---------- >> %LOG% 2>&1
echo ...Stopping MQ Queuemgr
echo ...Stopping MQ Queuemgr >> %LOG% 2>&1
endmqm -i %QMNAME% >> %LOG% 2>&1
echo. >> %LOG% 2>&1

echo ...Deleting MQ Queuemgr
echo ...Deleting MQ Queuemgr >> %LOG% 2>&1
dltmqm %QMNAME% >> %LOG% 2>&1


REM ----------------------- Delete EXE files and DLLs SECTION --------------------
echo. >> %LOG% 2>&1
echo.
echo Delete file section
echo ---------- Delete file section ---------- >> %LOG% 2>&1
echo ...Deleting files copies by last run (if they exist)
echo ...Deleting files copies by last run (if they exist) >> %LOG% 2>&1

echo ...cppwm35i.dll will be deleted (if it exists) when the directory is destroyed >> %LOG% 2>&1
echo ...cppwob3i.dll will be deleted (if it exists) when the directory is destroyed >> %LOG% 2>&1

if EXIST %MQI%\bin\sqlsvses.cfg goto EraseSqlsvses
echo ...sqlsvses.cfg not found in MQSeries Integrator \bin directory >> %LOG% 2>&1
goto NoErase3
:EraseSqlsvses
echo ...Deleting sqlsvses.cfg >> %LOG% 2>&1
erase %MQI%\bin\sqlsvses.cfg >> %LOG% 2>&1
:NoErase3

if EXIST %MQI%\bin\MQSIruleng.mpf goto EraseMqsiruleng
echo ...MQSIruleng.mpf not found in MQSeries Integrator \bin directory >> %LOG% 2>&1
goto NoErase4
:EraseMqsiruleng
echo ...Deleting MQSIruleng.mpf >> %LOG% 2>&1
erase %MQI%\bin\MQSIruleng.mpf >> %LOG% 2>&1
:NoErase4

echo Deleting any MQSI formatter error files if they exist... >> %LOG% 2>&1 
erase %MQI%\bin\nnfie.err* >> %LOG% 2>&1


REM ----------------------- DB2 SECTION --------------------
echo. >> %LOG% 2>&1
echo.
echo DB2 section
echo ---------- DB2 section ---------- >> %LOG% 2>&1
echo ...Start DB2 in case it is not running
echo ...Start DB2 in case it is not running >> %LOG% 2>&1
DB2START >> %LOG% 2>&1
echo. >> %LOG% 2>&1

echo ...Check database DBMSERV exists before we try and drop it
echo ...Check database DBMSERV exists before we try and drop it >> %LOG% 2>&1
DB2 LIST DB DIRECTORY > dblist.out
Findstr /c:"DBMSERV" dblist.out > nul 2>&1
if "%errorlevel%"=="0" goto DatabaseExists
echo Database DBMSERV does not exist... bypassing DB2 reset code.
echo Database DBMSERV does not exist... bypassing DB2 reset code. >> %LOG% 2>&1
goto DB2bypass

:DatabaseExists
echo Database DBMSERV exists
echo Database DBMSERV exists >> %LOG% 2>&1
echo. >> %LOG% 2>&1 

echo ...Reset connections
echo ...Reset connections >> %LOG% 2>&1
DB2 CONNECT RESET >> %LOG% 2>&1
echo. >> %LOG% 2>&1

echo ...Force all running aplications to terminate
echo ...Force all running aplications to terminate >> %LOG% 2>&1
DB2 FORCE APPLICATION ALL >> %LOG% 2>&1

echo ...Drop the database (DBMSERV)
echo ...Drop the database >> %LOG% 2>&1
set i=1st
:DropDB
DB2 DROP DATABASE DBMSERV >> %LOG% 2>&1
if "%ERRORLEVEL%"=="0" goto DBdropped
echo Drop failed... wait 5 seconds and retry for the %i% time >> %LOG% 2>&1
echo Drop failed... wait 5 seconds and retry for the %i% time 
delay
if "%i%"=="7th" goto DropFailed
if "%i%"=="6th" set i=7th
if "%i%"=="5th" set i=6th
if "%i%"=="4th" set i=5th
if "%i%"=="3rd" set i=4th
if "%i%"=="2nd" set i=3rd
if "%i%"=="1st" set i=2nd
goto DropDB
:DropFailed
echo *** ERROR *** 
echo   Drop of Database DBMSERV failed.  You will have to drop this database
echo   yourself using the following command from a DB2 command prompt
echo   "DB2 DROP DATABASE DBMSERV"
echo *** ERROR *** >> %LOG% 2>&1
echo   Drop of Database DBMSERV failed.  You will have to drop this database >> %LOG% 2>&1
echo   yourself using the following command from a DB2 command prompt >> %LOG% 2>&1
echo   "DB2 DROP DATABASE DBMSERV" >> %LOG% 2>&1
goto StopDB2
:DBdropped
echo Database DBMSERV dropped
echo Database DBMSERV dropped >> %LOG% 2>&1

:StopDB2
:DBdropped
:DB2bypass
echo. >> %LOG% 2>&1
echo ...Stop DB2
echo ...Stop DB2 >> %LOG% 2>&1
DB2STOP >> %LOG% 2>&1



REM ----------------------- REFRESH TESTDRIVE SECTION --------------------
echo. >> %LOG% 2>&1
echo.
echo Refresh Test Drive Section
echo ---------- Refresh Test Drive Section ---------- >> %LOG% 2>&1
echo ...Change to mqicpp directory >> %LOG% 2>&1
pushd %tsdemopath%\sdk\mqicpp >> %LOG% 2>&1
rem echo ...Remove TestDrive Directory (note that this will probably issue an error >> %LOG% 2>&1
rem echo ...indicating that it could not the directory, this is not a cause for concern) >> %LOG% 2>&1
rem rmdir TestDrive /s /q >> %LOG% 2>&1
echo ...Copy TestDriveCopy directory to TestDrive >> %LOG% 2>&1
xcopy TestDriveCopy TestDrive\*.* /s >> %LOG% 2>&1  


REM ----------------------- View Logfile --------------------
echo.
echo. >> %LOG% 2>&1
echo **** Test Drive RESET is Complete **** 
echo **** Test Drive RESET is Complete **** >> %LOG% 2>&1
start "Log from reset commands" notepad %LOG%

pause
exit
